//
// OpenIrekia v2.0 Cliente Android
//
// Copyright 2009-2011 eFaber, S.L.
// Copyright 2009-2011 Ejie, S.A.
// Copyrigth 2009-2011 Dirección de Gobierno Abierto y Comunicación en Internet; 
//    Gobernu Irekirako eta Interneteko Komunikaziorako Zuzendaritza; Lehendakaritza.
//    Gobierno Vasco – Eusko Jaurlaritza 
// Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas 
// por la Comisión Europea– versiones posteriores de la EUPL (la Licencia);
// Solo podrá usarse esta obra si se respeta la Licencia. Puede obtenerse una 
// copia de la Licencia en: http://ec.europa.eu/idabc/eupl 
// Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
// el programa distribuido con arreglo a la Licencia se distribuye TAL CUAL,
// SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
// Véase la Licencia en el idioma concreto que rige los permisos y limitaciones 
// que establece la Licencia
//
//  http://open.irekia.net, openirekia@efaber.net

package net.efaber.irekia;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.ProgressBar;
import android.widget.TextView;
import com.github.droidfu.activities.BetterDefaultActivity;
import net.efaber.irekia.activities.Restarter_activity;

/**
 * Wrapper to keep track of activity and share code.
 */
public class Irekia_default_activity extends BetterDefaultActivity {


	@Override
	protected void onCreate(Bundle savedInstanceState) {
		requestWindowFeature(Window.FEATURE_CUSTOM_TITLE);
		super.onCreate(savedInstanceState);
	}

	/**
	 * Check if we have to die.
	 * If we don't have to, increment the activity counter.
	 */
	@Override
	public void onResume() {
		super.onResume();
		if (null == Irekia.main_Overlord) {
			Intent intent = new Intent(this, Restarter_activity.class);
			startActivity(intent);
			finish();
		}
		if (Irekia.needs_restarting)
			finish();
		else
			Irekia.one_living(this);
	}

	/**
	 * Tells the global class we are dying.
	 */
	@Override
	public void onPause() {
		super.onPause();
		Irekia.one_dying();
	}


	@Override
	public void setTitle(CharSequence title) {
		if (findViewById(R.id.title) != null)
			((TextView) findViewById(R.id.title)).setText(title);
	}


	public final void setCustomProgressBarVisibility(boolean visible) {
		if (findViewById(R.id.progress_bar) != null) {
			((ProgressBar) findViewById(R.id.progress_bar)).setProgressDrawable(getResources().getDrawable(R.drawable.custom_progress));
			findViewById(R.id.progress_bar).setVisibility(visible ? ProgressBar.VISIBLE : ProgressBar.GONE);
		}
	}

	public final void setCustomProgressBarIndeterminateVisibility(boolean visible) {
		if (findViewById(R.id.top_refresh) != null)
			findViewById(R.id.top_refresh).setVisibility(visible ? View.GONE : View.VISIBLE);
		if (findViewById(R.id.loading) != null)
			findViewById(R.id.loading).setVisibility(visible ? ProgressBar.VISIBLE : ProgressBar.GONE);
	}

	public final void setCustomProgress(int progress) {
		ProgressBar pbar = (ProgressBar) findViewById(R.id.progress_bar);
		if (pbar != null) {
			pbar.setProgress(progress);
			if (progress == 10000 || pbar.getProgress() == pbar.getMax()) {
				pbar.setProgress(0);
				pbar.setVisibility(ProgressBar.GONE);
				setCustomProgressBarIndeterminateVisibility(false);
			}
		}
	}


}
