package net.efaber.irekia.activities.util;

import android.graphics.drawable.Drawable;
import android.view.MotionEvent;
import android.view.View;
import android.widget.EditText;
import net.efaber.irekia.R;

import java.util.concurrent.Callable;

public final class CleaningEditText {


	public CleaningEditText(EditText txt) {
		this(txt, null, true);
	}

	public CleaningEditText(EditText txt, boolean checkingEnabled) {
		this(txt, null, checkingEnabled);
	}

	public CleaningEditText(final EditText txt, final Callable<Void> m) {
		this(txt, m, true);
	}

	public CleaningEditText(final EditText txt, final Callable<Void> m, boolean checkingEnabled) {
		if (checkingEnabled && (!txt.isEnabled() || !txt.isFocusable()))
			return;
		final Drawable x = txt.getContext().getResources().getDrawable(R.drawable.clear_text);
		x.setBounds(0, 0, x.getIntrinsicWidth(), x.getIntrinsicHeight());
		txt.setCompoundDrawables(null, null, x, null);
		txt.setOnTouchListener(new View.OnTouchListener() {
			public boolean onTouch(View v, MotionEvent event) {
				if (txt.getCompoundDrawables()[2] == null) {
					return false;
				}
				if (event.getAction() != MotionEvent.ACTION_DOWN) {
					return false;
				}
				if (event.getX() > txt.getMeasuredWidth() -
					txt.getPaddingRight() - x.getIntrinsicWidth()) {
					txt.setText("");
					try {
						if (m != null)
							m.call();
					} catch (Exception e) {
						System.out.println("ERROR cleaning text: " + e.getMessage());
					}
					return true;
				} else {
					return false;
				}
			}
		});

	}
}
