//
// OpenIrekia v2.0 Cliente Android
//
// Copyright 2009-2011 eFaber, S.L.
// Copyright 2009-2011 Ejie, S.A.
// Copyrigth 2009-2011 Dirección de Gobierno Abierto y Comunicación en Internet; 
//    Gobernu Irekirako eta Interneteko Komunikaziorako Zuzendaritza; Lehendakaritza.
//    Gobierno Vasco – Eusko Jaurlaritza 
// Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas 
// por la Comisión Europea– versiones posteriores de la EUPL (la Licencia);
// Solo podrá usarse esta obra si se respeta la Licencia. Puede obtenerse una 
// copia de la Licencia en: http://ec.europa.eu/idabc/eupl 
// Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
// el programa distribuido con arreglo a la Licencia se distribuye TAL CUAL,
// SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
// Véase la Licencia en el idioma concreto que rige los permisos y limitaciones 
// que establece la Licencia
//
//  http://open.irekia.net, openirekia@efaber.net

package net.efaber.irekia.childcontroller;

import android.os.Bundle;
import android.view.*;
import android.view.ContextMenu.ContextMenuInfo;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ImageButton;
import android.widget.TextView;
import net.efaber.irekia.*;
import net.efaber.irekia.activities.util.ExpandableHeightGridView;
import net.efaber.irekia.gallery.Gallery_data;
import net.efaber.irekia.models.Activity_progress;
import net.efaber.irekia.models.Gallery_item;

import java.text.ParseException;
import java.util.Observable;
import java.util.Observer;

/**
 * Shows a list of items.
 */
public class Child_gallery_activity extends Irekia_default_activity
	implements Observer, OnItemClickListener, Activity_progress {
	private Child_gallery_adapter adapter;
	private ExpandableHeightGridView g;

	private Post_rotation r;

	/// Stores the last known progress.
	private int last_progress = 10000;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.photo_gallery);
		getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.title_refresh);
		setCustomProgressBarIndeterminateVisibility(true);
		setCustomProgressBarVisibility(true);
		findViewById(R.id.title_icon).setVisibility(View.GONE);
		ImageButton homeBtn = (ImageButton) findViewById(R.id.title_icon_back);
		homeBtn.setVisibility(View.VISIBLE);
		homeBtn.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {
				if (Irekia.main_Overlord != null)
					Irekia.main_Overlord.go_home(Child_gallery_activity.this);
			}
		});
		findViewById(R.id.top_refresh).setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {
				if (null != Irekia.main_Overlord && null != Irekia.main_Overlord.last_selected_item) {
					setCustomProgressBarIndeterminateVisibility(true);
					setCustomProgressBarVisibility(true);
					Irekia.main_Overlord.fetch_child_items(Irekia.main_Overlord.last_selected_item.get_langcode_url());
				}
			}
		});
		// Recover rotation persistant variables.
		r = (Post_rotation) getLastNonConfigurationInstance();
		if (null == r)
			r = new Post_rotation();

		Bundle extras = getIntent().getExtras();
		String title = "Irekia";
		if (null != extras) {
			if (extras.getString(Irekia.TITLE_PARAM) != null)
				title = extras.getString(Irekia.TITLE_PARAM);
		}
		setTitle(title);

		if (null == Irekia.main_Overlord)
			return;
		Irekia.main_Overlord.set_progress_reporter(this);
		if (Irekia.main_Overlord != null && Irekia.main_Overlord.last_selected_item != null && Irekia.main_Overlord.last_selected_item.isOverlord()) {
			Irekia.main_Overlord.fetch_child_items(Irekia.main_Overlord.last_selected_item.get_langcode_url());
		}

		Gallery_data gallery_data;
		if (null == Irekia.main_Overlord.last_selected_item)
			return;
		try {
			if (Irekia.main_Overlord.last_selected_item.data != null)
				gallery_data = new Gallery_data(Irekia.main_Overlord.last_selected_item.data);
			else
				gallery_data = new Gallery_data(Irekia.main_Overlord.generic_gallery_data);
		} catch (ParseException e) {
			e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
			return;
		}

		adapter = new Child_gallery_adapter(this, gallery_data);
		adapter.set_items(Irekia.main_Overlord.child_items);

		g = (ExpandableHeightGridView) findViewById(R.id.gallery_grid);
		g.setId(13);
		g.setAdapter(adapter);

		// Configure some looks for the grid.
		g.setNumColumns(gallery_data.cells_per_row);
		g.setGravity(Gravity.CENTER);
		g.setVerticalSpacing((int) (gallery_data.padding * 2 * Irekia.density));
		g.setHorizontalSpacing((int) (gallery_data.padding * 2 * Irekia.density));

		g.setBackgroundColor(android.R.color.black);
		g.setDrawingCacheBackgroundColor(android.R.color.black);
		g.setCacheColorHint(android.R.color.black);

		g.setOnItemClickListener(this);
		g.setExpanded(true);
		registerForContextMenu(g);
		if (Irekia.main_Overlord != null && Irekia.main_Overlord.last_selected_item != null && Irekia.main_Overlord.last_selected_item.can_fetch_more()
			&& Irekia.main_Overlord.current_paginated_result.can_fetch_more()) {
			//Create more_items_row to allow user to ask for new items
			final View more_items_row = findViewById(R.id.more_items_row_layout);
			((TextView) findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.MORE_ITEMS));
			more_items_row.setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View view) {
					//Change more_items_row state to show loading spinner
					findViewById(R.id.items_loading_spinner).setVisibility(View.VISIBLE);
					((TextView) findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.DOWNLOADING_DATA));
					//Avoid asking for more items until last search is ended
					more_items_row.setClickable(false);
					//Ask for more data
					Irekia.main_Overlord.fetch_more_child();
				}
			});
		}
		findViewById(R.id.more_items_row_layout).setVisibility(View.GONE);
		Irekia.set_empty_view(g, this);
	}

	public void onResume() {
		super.onResume();
		if (null == Irekia.main_Overlord)
			return;
		Irekia.main_Overlord.set_progress_reporter(this);
		Irekia.main_Overlord.child_items.addObserver(this);
		if (!Irekia.isNetworkAvailable())
			findViewById(R.id.more_items_row_layout).setVisibility(View.GONE);
		if (Irekia.is_tablet && Irekia.close_prev) {
			Irekia.close_prev = false;
			this.finish();
			return;
		}
	}

	@Override
	public void update(Observable observable, Object data) {
		int scrollY = findViewById(R.id.parent_scroll).getScrollY();
		int scrollX = findViewById(R.id.parent_scroll).getScrollX();
		//If Overlord is able to fetch more items...
		if (Irekia.main_Overlord != null && Irekia.main_Overlord.last_selected_item != null
			&& Irekia.main_Overlord.last_selected_item.can_fetch_more()
			&& Irekia.main_Overlord.current_paginated_result.can_fetch_more()
			&& Irekia.main_Overlord.last_selected_item.has_older) {
			findViewById(R.id.more_items_row_layout).setVisibility(View.VISIBLE);
			//Change_more_items_row state
			findViewById(R.id.more_items_row_layout).findViewById(R.id.items_loading_spinner).setVisibility(View.GONE);
			((TextView) findViewById(R.id.more_items_row_layout).findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.MORE_ITEMS));
			findViewById(R.id.more_items_row_layout).setClickable(true);
		}
		r.last_fetch = Irekia.main_Overlord.last_update;
		adapter.set_items(Irekia.main_Overlord.child_items);
		adapter.notifyDataSetChanged();
		findViewById(R.id.parent_scroll).scrollTo(scrollX, scrollY);
	}

	/**
	 * Pass some parameters to our future self after rotation.
	 * We want to preserve some data like the r.last_fetch timestamp after a
	 * rotation, so we communicate it here.
	 */
	@Override
	public Object onRetainNonConfigurationInstance() {
		return r;
	}


	/**
	 * Handles the user clicking or selecting an item with.
	 * The item's url will be loaded in a new web activity.
	 */
	@Override
	public void onItemClick(AdapterView<?> parent, View view, int pos, long id) {
		Gallery_item item = (Gallery_item) Irekia.main_Overlord.child_items.get(pos);
		item.start_child_activity(this, Irekia.main_Overlord);
	}

	/**
	 * Interface to let the Overlord notify us of download progresses.
	 */
	public void set_progress(int progress) {
		last_progress = progress;
		setCustomProgress(progress);
	}

	@Override
	public void onPause() {
		super.onPause();
		if (null == Irekia.main_Overlord)
			return;
		Irekia.main_Overlord.child_items.deleteObserver(this);
	}

	/**
	 * ******************** Common activity options menu **********************
	 */

	/**
	 * The user pressed the menu button, create the menu.
	 */
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		return Activity_options.onCreateChildOptionsMenu(this, menu, Irekia.main_Overlord);
	}

	/**
	 *
	 * The user selected a menu option, what should we do?
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		return Activity_options.onOptionsItemSelected(this, item, Irekia.main_Overlord);
	}


	/**
	 * ******************************* Sharekit *******************************
	 */

	@Override
	public void onCreateContextMenu(ContextMenu menu, View v,
									ContextMenuInfo menuInfo) {
		super.onCreateContextMenu(menu, v, menuInfo);
		Sharekit.onCreateContextMenu(this, menu, v, menuInfo);
	}

	@Override
	public boolean onContextItemSelected(MenuItem item) {
		return Sharekit.onVolatileContextItemSelected(this, item, Irekia.main_Overlord);
	}

/****************************************************************************/

	/**
	 * Custom private class to preserve data between rotations.
	 */
	private class Post_rotation {
		public long last_fetch;
		public boolean did_fetch;
	}

}
