package net.efaber.irekia.childcontroller;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.*;
import android.view.inputmethod.EditorInfo;
import android.view.inputmethod.InputMethodManager;
import android.widget.*;
import net.efaber.irekia.*;
import net.efaber.irekia.activities.util.CleaningEditText;
import net.efaber.irekia.login.Login_web_activity;
import net.efaber.irekia.models.Activity_progress;
import net.efaber.irekia.models.News_item;
import net.efaber.irekia.models.Section_state;
import net.efaber.irekia.news.News_data;
import net.efaber.irekia.news.News_row;
import net.efaber.irekia.social.Social_Activity;
import net.efaber.irekia.volatilecontroller.Volatile_list_activity;

import java.text.ParseException;
import java.util.Observable;
import java.util.Observer;

public class Child_list_activity extends Irekia_expandable_list_activity
	implements Observer, ExpandableListView.OnChildClickListener, Activity_progress, Social_Activity {

	private Post_rotation r;
	/// Watchdog to control and know if is needed to restore previous items (back navigations)
	private boolean restore_previous_items_needed = false;
	private boolean is_sharing = false;
	private boolean is_navigating_to_child = false;
	private View empty = null;
	private ProgressDialog progressDialog;
	private boolean must_focus_search = false;

	/// Stores the last known progress.
	private int last_progress = 10000;


	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		restore_previous_items_needed = false;
		setContentView(R.layout.expandable_search);
		getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.title_refresh);
		setCustomProgressBarIndeterminateVisibility(true);
		findViewById(R.id.title_icon).setVisibility(View.GONE);
		ImageButton homeBtn = (ImageButton) findViewById(R.id.title_icon_back);
		homeBtn.setVisibility(View.VISIBLE);
		homeBtn.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {
				if (Irekia.main_Overlord != null)
					Irekia.main_Overlord.go_home(Child_list_activity.this);
			}
		});
		findViewById(R.id.top_refresh).setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {
				if (null != Irekia.main_Overlord && null != Irekia.main_Overlord.last_selected_item) {
					setCustomProgressBarIndeterminateVisibility(true);
					setCustomProgressBarVisibility(true);
					Irekia.main_Overlord.fetch_child_items(Irekia.main_Overlord.last_selected_item.get_langcode_url());
				}
			}
		});

		setCustomProgressBarVisibility(true);
		progressDialog = new ProgressDialog(this);
		progressDialog.setCancelable(false);

		// Recover rotation persistant variables.
		r = (Post_rotation) getLastNonConfigurationInstance();
		if (null == r)
			r = new Post_rotation();

		Bundle extras = getIntent().getExtras();
		String title = "Irekia";
		if (null != extras) {
			if (extras.getString(Irekia.TITLE_PARAM) != null)
				title = extras.getString(Irekia.TITLE_PARAM);
		}
		if (null == Irekia.main_Overlord)
			return;
		Irekia.main_Overlord.set_progress_reporter(this);

		if (Irekia.main_Overlord != null && Irekia.main_Overlord.last_selected_item != null && (Irekia.main_Overlord.last_selected_item.isOverlord()))
			Irekia.main_Overlord.fetch_child_items(Irekia.main_Overlord.last_selected_item.get_langcode_url());
		setTitle(title);

		News_data news_data;
		if (null == Irekia.main_Overlord.last_selected_item)
			return;
		try {
			if (Irekia.main_Overlord.last_selected_item.data != null)
				news_data = new News_data(Irekia.main_Overlord.last_selected_item.data);
			else
				news_data = new News_data(Irekia.main_Overlord.generic_news_data);
		} catch (ParseException e) {
			e.printStackTrace();
			return;
		}
		ExpandableListView l = getExpandableListView();
		l.setId(android.R.id.list);
		l.setChildDivider(getResources().getDrawable(R.color.r_light_gray));
		l.setDivider(getResources().getDrawable(R.color.r_light_gray));
		l.setDividerHeight((int) (Irekia.density + 0.5f));
		l.setGroupIndicator(getResources().getDrawable(R.drawable.empty_expandable));
		Child_news_adapter adapter = new Child_news_adapter(this, news_data);
		//Create more_items_row to allow user to ask for new items

		final View more_items_row = getLayoutInflater().inflate(R.layout.load_more_items, null);
		((TextView) more_items_row.findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.MORE_ITEMS));
		more_items_row.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {
				//Change more_items_row state to show loading spinner
				more_items_row.findViewById(R.id.items_loading_spinner).setVisibility(View.VISIBLE);
				((TextView) more_items_row.findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.DOWNLOADING_DATA));
				//Avoid asking for more items until last search is ended
				more_items_row.setClickable(false);
				//Fetch more child items
				Irekia.main_Overlord.fetch_more_child();
			}
		});

		adapter.set(Irekia.main_Overlord);
		//if Overlord current result can fetch more items Add more_items_row
		if (Irekia.main_Overlord != null && Irekia.main_Overlord.last_selected_item != null && Irekia.main_Overlord.last_selected_item.can_fetch_more()
			&& Irekia.main_Overlord.current_paginated_result.can_fetch_more()) {
			l.addFooterView(more_items_row);
			more_items_row.setVisibility(View.VISIBLE);

		} else
			//Update more_items_row visibility
			more_items_row.setVisibility(View.GONE);
		setListAdapter(adapter);
		l.setOnGroupCollapseListener(adapter);
		l.setOnGroupExpandListener(adapter);
		// Configure some looks for the listview.
		findViewById(R.id.main_layout).setBackgroundColor(news_data.back_normal_color);
		l.setBackgroundColor(news_data.back_normal_color);
		l.setDrawingCacheBackgroundColor(news_data.back_normal_color);
		l.setCacheColorHint(news_data.back_normal_color);

		l.setOnChildClickListener(this);
		registerForContextMenu(l);
		l.setVisibility(View.GONE);
		empty = getLayoutInflater().inflate(R.layout.empty, (ViewGroup) l.getParent(), false);
		TextView text = (TextView) empty.findViewById(R.id.connecting_text);
		if (null != text)
			text.setText(I18n.e(I18n.Embedded_string.CONNECTING_TO_SERVER));
		((ViewGroup) l.getParent()).addView(empty);
		init_search();
	}

	private void init_search() {
		if (Irekia.main_Overlord == null || Irekia.main_Overlord.last_selected_item == null || !Irekia.main_Overlord.last_selected_item.is_searchable())
			return;
		findViewById(R.id.search_bar).setVisibility(View.GONE);
		final Button searchBtn = (Button) findViewById(R.id.search_go_btn);
		searchBtn.setEnabled(false);
		final EditText search_wrds = (EditText) findViewById(R.id.search_src_text);
		new CleaningEditText(search_wrds, true);
		search_wrds.setHint(I18n.e(I18n.Embedded_string.SEARCH_PLACEHOLDER));
		search_wrds.addTextChangedListener(new TextWatcher() {
			@Override
			public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {
			}

			@Override
			public void onTextChanged(CharSequence charSequence, int i, int i1, int i2) {
				searchBtn.setEnabled(charSequence.toString().length() > 0 ? true : false);
			}

			@Override
			public void afterTextChanged(Editable editable) {
			}
		});

		searchBtn.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {
				perform_search(search_wrds);
				findViewById(R.id.search_bar).setVisibility(View.GONE);
			}
		});
		search_wrds.setOnEditorActionListener(new TextView.OnEditorActionListener() {
			@Override
			public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
				if (actionId == EditorInfo.IME_ACTION_SEARCH || event.getKeyCode() == KeyEvent.KEYCODE_ENTER) {
					if (search_wrds.getText().toString().length() > 0) {
						perform_search(search_wrds);
						findViewById(R.id.search_bar).setVisibility(View.GONE);
					}
					return true;
				}
				return false;
			}
		});
	}

	public void toggle_search() {
		View searchBar = findViewById(R.id.search_bar);
		if (searchBar != null) {
			if (searchBar.getVisibility() == View.GONE) {
				searchBar.setVisibility(View.VISIBLE);
				final EditText search_wrds = (EditText) findViewById(R.id.search_src_text);
				search_wrds.requestFocus();
				InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
				imm.toggleSoftInput(0, 0);
			} else
				searchBar.setVisibility(View.GONE);
		}
	}

	private void perform_search(EditText search_wrds) {
		if (Irekia.main_Overlord == null || Irekia.main_Overlord.last_selected_item == null || !Irekia.main_Overlord.last_selected_item.is_searchable())
			return;
		Irekia.main_Overlord.search(search_wrds.getText().toString());
		Intent intent = new Intent().setClass(this, Volatile_list_activity.class);
		intent.putExtra(Irekia.TITLE_PARAM, I18n.e(I18n.Embedded_string.IREKIA_SEARCH_WINDOW_TITLE) + search_wrds.getText().toString());
		intent.putExtra(Irekia.MODE_PARAM, Irekia.MODE_SEARCH);
		search_wrds.setText("");
		InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
		imm.toggleSoftInput(0, 0);
		startActivity(intent);
	}


	@Override
	public boolean onSearchRequested() {
		if (Irekia.main_Overlord == null || Irekia.main_Overlord.last_selected_item == null || !Irekia.main_Overlord.last_selected_item.is_searchable())
			return false;
		findViewById(R.id.search_bar).setVisibility(View.VISIBLE);
		final EditText search_wrds = (EditText) findViewById(R.id.search_src_text);
		search_wrds.requestFocus();
		InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
		imm.showSoftInput(search_wrds, InputMethodManager.SHOW_FORCED);
		return false;
	}


	@Override
	protected void onRestart() {
		super.onRestart();
		must_focus_search = Irekia.must_focus_search;
		getExpandableListView().setVisibility(View.VISIBLE);
		if (empty != null)
			empty.setVisibility(View.GONE);
		if (!is_sharing && is_navigating_to_child)
			restore_previous_items_needed = true;
		is_sharing = false;
		setCustomProgressBarVisibility(false);
	}

	@Override
	public void onResume() {
		super.onResume();
		must_focus_search = Irekia.must_focus_search;
		final EditText search_wrds = (EditText) findViewById(R.id.search_src_text);
		final Button searchBtn = (Button) findViewById(R.id.search_go_btn);
		if (search_wrds != null && search_wrds.getText().length() > 0)
			if (searchBtn != null)
				searchBtn.setEnabled(true);
		if (null == Irekia.main_Overlord)
			return;
		Irekia.main_Overlord.set_progress_reporter(this);
		is_navigating_to_child = false;
		Irekia.main_Overlord.child_items.addObserver(this);
		if (restore_previous_items_needed) {
			Irekia.main_Overlord.restore_previous_items();
			if (Irekia.is_tablet && Irekia.close_prev) {
				Irekia.close_prev = false;
				this.finish();
				return;
			}
		}
		update_collapsed_state(getExpandableListView(),
			(Child_news_adapter) getExpandableListAdapter());
		if (must_focus_search) {
			Irekia.must_focus_search = false;
			findViewById(R.id.search_bar).setVisibility((Irekia.main_Overlord.last_selected_item != null && Irekia.main_Overlord.last_selected_item.is_searchable()) ? View.VISIBLE : View.GONE);
			search_wrds.requestFocus();
		} else
			findViewById(R.id.search_bar).setVisibility(View.GONE);
	}

	@Override
	public void onPause() {
		super.onPause();
		if (null == Irekia.main_Overlord)
			return;
		Irekia.main_Overlord.child_items.deleteObserver(this);
		if(Irekia.is_tablet)
			Irekia.main_Overlord.last_list_visible_child = getExpandableListView().getFirstVisiblePosition();
		if (!is_navigating_to_child)
			restore_previous_items_needed = false;
	}

	/**
	 * Pass some parameters to our future self after rotation.
	 * We want to preserve some data like the r.last_fetch timestamp after a
	 * rotation, so we communicate it here.
	 */
	@Override
	public Object onRetainNonConfigurationInstance() {
		return r;
	}

	/**
	 * Handles the user clicking or selecting an item with.
	 * The item's url will be loaded in a new web activity.
	 */
	@Override
	public boolean onChildClick(ExpandableListView parent, View view, int groupPosition, int childPosition, long id) {
		News_item item = (News_item) parent.getExpandableListAdapter().getChild(
			groupPosition, childPosition);
		is_navigating_to_child = true;
		if (item.isOverlord() && !item.class_type.equals("Follow_cell")) { // And not logued
			Irekia.main_Overlord.save_previous_items(true);
			Irekia.main_Overlord.last_selected_item = item;
		} else if (!item.class_type.equals("Follow_cell") || (item.class_type.equals("Follow_cell") && !Irekia.user_auth_info.is_Logged()))
			Irekia.main_Overlord.save_previous_items(false);
		if (null != item) {
			item.start_child_activity(this, Irekia.main_Overlord);
			return true;
		} else {
			Toast.makeText(this, "Internal error processing item id!",
				Toast.LENGTH_SHORT).show();
			return false;
		}
	}

	/**
	 * Modifies the collapsed state of all groups in a listview.
	 * The collapsed state comes out of the attribute for the Section_state objects.
	 */

	protected void update_collapsed_state(ExpandableListView list,
										  Child_news_adapter adapter) {
		for (int f = 0; f < adapter.getGroupCount(); f++) {
			Section_state section = adapter.getGroup(f);
			if (null != section) {
				if (section.collapsed)
					list.collapseGroup(f);
				else
					list.expandGroup(f);
			} else {
				list.expandGroup(f);
			}
		}
	}

	/**
	 * Interface to let the Overlord notify us of download progresses.
	 */
	public void set_progress(int progress) {
		last_progress = progress;
		setCustomProgress(progress);
		View more_items = findViewById(R.id.more_items_row_layout);
		//If current result has not more results hide more_items_row
		if (progress == 10000 && more_items != null && Irekia.main_Overlord != null && Irekia.main_Overlord.last_selected_item != null
			&& !(Irekia.main_Overlord.last_selected_item.can_fetch_more()
			|| Irekia.main_Overlord.current_paginated_result.can_fetch_more())) {
			findViewById(R.id.more_items_row_layout).findViewById(R.id.more_items_row_layout).setVisibility(View.GONE);
			findViewById(R.id.more_items_row_layout).findViewById(R.id.items_loading_spinner).setVisibility(View.GONE);
			((TextView) findViewById(R.id.more_items_row_layout).findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.MORE_ITEMS));
			findViewById(R.id.more_items_row_layout).setClickable(false);
		}
		if (progress == 10000 && Irekia.main_Overlord.child_items.size() == 0) {
			TextView text = (TextView) empty.findViewById(R.id.connecting_text);
			text.setText(Irekia.main_Overlord.last_selected_item != null ? Irekia.main_Overlord.last_selected_item.get_empty_message() : I18n.e(I18n.Embedded_string.IREKIA_NO_RESULTS));
			empty.setVisibility(View.VISIBLE);
		}
	}

/*********************** Common activity options menu ***********************/

	/**
	 * The user pressed the menu button, create the menu.
	 */
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		return Activity_options.onCreateChildOptionsMenu(this, menu, Irekia.main_Overlord);
	}

	/**
	 * The user selected a menu option, what should we do?
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		return Activity_options.onOptionsItemSelected(this, item, Irekia.main_Overlord);
	}


	/**
	 * ******************************* Sharekit *******************************
	 */

	@Override
	public void onCreateContextMenu(ContextMenu menu, View v,
									ContextMenu.ContextMenuInfo menuInfo) {
		ExpandableListView.ExpandableListContextMenuInfo info = (ExpandableListView.ExpandableListContextMenuInfo) menuInfo;
		News_item content_item = ((News_row) info.targetView).get_content_item();
		if (content_item != null && (content_item.class_type.equals("Login_cell")) || content_item.class_type.equals("Follow_cell") || content_item.share_url == null || content_item.share_url.equals(""))
			return;
		super.onCreateContextMenu(menu, v, menuInfo);
		Sharekit.onCreateContextMenu(this, menu, v, menuInfo);
	}

	@Override
	public boolean onContextItemSelected(MenuItem item) {
		is_sharing = true;
		return Sharekit.onVolatileContextItemSelected(this, item, Irekia.main_Overlord);
	}

	/**
	 * Gets notifications about updates to the list of Overlord items.
	 * The observable will actually be the overlord. The data is always null (?).
	 */
	@Override
	public void update(Observable observable, Object data) {

		//If current result has more results change state
		if (Irekia.main_Overlord != null && Irekia.main_Overlord.last_selected_item != null
			&& Irekia.main_Overlord.last_selected_item.can_fetch_more()
			&& Irekia.main_Overlord.current_paginated_result.can_fetch_more()
			&& Irekia.main_Overlord.last_selected_item.has_older) {
			//Change_more_items_row state
			if (findViewById(R.id.more_items_row_layout) != null) {
				if (findViewById(R.id.more_items_row_layout).findViewById(R.id.items_loading_spinner) != null)
					findViewById(R.id.more_items_row_layout).findViewById(R.id.items_loading_spinner).setVisibility(View.GONE);
				if (findViewById(R.id.more_items_row_layout).findViewById(R.id.more_items_text) != null)
					((TextView) findViewById(R.id.more_items_row_layout).findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.MORE_ITEMS));
				findViewById(R.id.more_items_row_layout).setClickable(true);
			}
		}
		Child_news_adapter adapter = (Child_news_adapter) getExpandableListAdapter();
		adapter.set(Irekia.main_Overlord);
		getExpandableListView().setVisibility(View.VISIBLE);
		if (empty != null)
			empty.setVisibility(View.GONE);
		update_collapsed_state(getExpandableListView(), adapter);
		if (must_focus_search) {
			InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
			imm.toggleSoftInput(0, 0);
		}
	}


	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		if (keyCode == KeyEvent.KEYCODE_BACK) {
			if (Irekia.main_Overlord != null)
				Irekia.main_Overlord.cancel_child_fetching();
			View searchBar = findViewById(R.id.search_bar);
			if (searchBar != null && searchBar.getVisibility() == View.VISIBLE) {
				searchBar.setVisibility(View.GONE);
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}


	/**
	 * Method that gets called when the settings activity has finished.
	 * Now we can pick up the list of changes and see if we need to refresh
	 * ourselves.
	 */
	@Override
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		super.onActivityResult(requestCode, resultCode, data);
		Activity_options.onActivityResult(this, requestCode);
	}

	@Override
	public void cancelDialog() {
		if (this.progressDialog.isShowing())
			this.progressDialog.cancel();
	}

	@Override
	public void showDialog(String message) {
		progressDialog.setMessage(message);
		progressDialog.show();
	}

	@Override
	public void needsLogin() {
		Intent intent = new Intent(Child_list_activity.this, Login_web_activity.class);
		intent.putExtra(Irekia.MAIN_LOGIN_ORIGIN_PARAM, false);
		startActivity(intent);
	}

	@Override
	public void showToast(String message) {
		Toast.makeText(this, message, Toast.LENGTH_LONG).show();
	}

	@Override
	public void reload() {
		Irekia.main_Overlord.fetch_child_items(Irekia.main_Overlord.last_selected_item.get_langcode_url());
	}


/****************************************************************************/

	/**
	 * Custom private class to preserve data between rotations.
	 */
	private class Post_rotation {
		public long last_fetch;
		public boolean did_fetch;
	}

}
