//
// OpenIrekia v2.0 Cliente Android
//
// Copyright 2009-2011 eFaber, S.L.
// Copyright 2009-2011 Ejie, S.A.
// Copyrigth 2009-2011 Dirección de Gobierno Abierto y Comunicación en Internet; 
//    Gobernu Irekirako eta Interneteko Komunikaziorako Zuzendaritza; Lehendakaritza.
//    Gobierno Vasco – Eusko Jaurlaritza 
// Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas 
// por la Comisión Europea– versiones posteriores de la EUPL (la Licencia);
// Solo podrá usarse esta obra si se respeta la Licencia. Puede obtenerse una 
// copia de la Licencia en: http://ec.europa.eu/idabc/eupl 
// Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
// el programa distribuido con arreglo a la Licencia se distribuye TAL CUAL,
// SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
// Véase la Licencia en el idioma concreto que rige los permisos y limitaciones 
// que establece la Licencia
//
//  http://open.irekia.net, openirekia@efaber.net

package net.efaber.irekia.childcontroller;

import android.os.Bundle;
import android.view.*;
import android.widget.*;
import android.widget.AdapterView.OnItemClickListener;
import net.efaber.irekia.*;
import net.efaber.irekia.I18n.Embedded_string;
import net.efaber.irekia.activities.util.ExpandableHeightGridView;
import net.efaber.irekia.gallery.Gallery_data;
import net.efaber.irekia.models.Activity_progress;
import net.efaber.irekia.models.Content_item;
import net.efaber.irekia.models.Gallery_item;

import java.text.ParseException;
import java.util.Observable;
import java.util.Observer;

/**
 * Shows a list of items.
 */
public class Child_strip_activity extends Irekia_default_activity
	implements OnItemClickListener, View.OnClickListener, Observer, Activity_progress {
	/// The adapter, reused from the Gallery_activity but using fullscreen mode.
	private Child_gallery_adapter adapter;
	private Child_gallery_adapter grid_adapter;
	/// The buttons used to navigate news. Might be hidden.
	private Navigation_buttons buttons;
	/// Points to the gallery, we need to interact with it frequently.
	private Gallery gallery;

	/// Points to the previous limit warning toast, to avoid spamming the user.
	private Toast last_limit_toast;
	/// Points to the previous description toast, to avoid spamming the user.
	private Toast last_desc_toast;
	private ExpandableHeightGridView g;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.strip);
		getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.title);
		findViewById(R.id.title_icon_back).setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {
				if (Irekia.main_Overlord != null)
					Irekia.main_Overlord.go_home(Child_strip_activity.this);
			}
		});
		buttons = new Navigation_buttons(this, this);

		// Hide the buttons if the user enabled hardware key navigation.
		if (Irekia.volume_key_navigation) {
			LinearLayout button_layout =
				(LinearLayout) findViewById(R.id.button_layout);
			if (null != button_layout)
				button_layout.setVisibility(View.GONE);
		}

		gallery = (Gallery) findViewById(R.id.strip);

		Bundle extras = getIntent().getExtras();
		if (null == Irekia.main_Overlord)
			return;

		Gallery_data gallery_data;
		if (null == Irekia.main_Overlord.last_selected_item)
			return;
		try {
			gallery_data = new Gallery_data(Irekia.main_Overlord.last_selected_item.data);
		} catch (ParseException e) {
			e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
			return;
		}
		adapter = new Child_gallery_adapter(this, gallery_data);
		adapter.fullscreen = true;
		adapter.set_items(Irekia.main_Overlord.child_items);

		gallery.setId(14);
		gallery.setAdapter(adapter);

		// Find the correct identifier and select it.
		final int id = extras.getInt(Irekia.CONTENT_ID_PARAM, -1);
		int f = 0;
		for (Content_item item : Irekia.main_Overlord.child_items) {
			if (id == item.id) {
				gallery.setSelection(f, false);
				break;
			}
			f++;
		}
		gallery.setOnItemClickListener(this);
		buttons.update(Irekia.main_Overlord, get_current_item());
		setTitle(R.string.app_name);
		if (Irekia.is_tablet)
			initParentList(gallery_data);
	}

	private void initParentList(Gallery_data gallery_data) {
		Irekia.main_Overlord.set_progress_reporter(this);

		grid_adapter = new Child_gallery_adapter(this, gallery_data);
		grid_adapter.set_items(Irekia.main_Overlord.child_items);
		g = (ExpandableHeightGridView) findViewById(R.id.gallery_grid);
		g.setId(13);
		g.setAdapter(grid_adapter);

		// Configure some looks for the grid.
		g.setNumColumns(gallery_data.cells_per_row);
		g.setGravity(Gravity.CENTER);
		g.setVerticalSpacing((int) (gallery_data.padding * 2 * Irekia.density));
		g.setHorizontalSpacing((int) (gallery_data.padding * 2 * Irekia.density));

		g.setBackgroundColor(android.R.color.black);
		g.setDrawingCacheBackgroundColor(android.R.color.black);
		g.setCacheColorHint(android.R.color.black);

		g.setOnItemClickListener(new OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> adapterView, View view, int pos, long l) {
				gallery.setSelection(pos);
				buttons.update(Irekia.main_Overlord, get_current_item());
			}
		});
		g.setExpanded(true);
		registerForContextMenu(g);
		if (Irekia.main_Overlord != null && Irekia.main_Overlord.last_selected_item != null && Irekia.main_Overlord.last_selected_item.can_fetch_more()
			&& Irekia.main_Overlord.current_paginated_result.can_fetch_more()) {
			//Create more_items_row to allow user to ask for new items
			final View more_items_row = findViewById(R.id.more_items_row_layout);
			((TextView) findViewById(R.id.more_items_text)).setText(I18n.e(Embedded_string.MORE_ITEMS));
			more_items_row.setOnClickListener(new View.OnClickListener() {
				@Override
				public void onClick(View view) {
					//Change more_items_row state to show loading spinner
					findViewById(R.id.items_loading_spinner).setVisibility(View.VISIBLE);
					((TextView) findViewById(R.id.more_items_text)).setText(I18n.e(Embedded_string.DOWNLOADING_DATA));
					//Avoid asking for more items until last search is ended
					more_items_row.setClickable(false);
					//Ask for more data
					Irekia.main_Overlord.fetch_more_child();
				}
			});
		}
		findViewById(R.id.more_items_row_layout).setVisibility(View.GONE);
	}

	@Override
	public void onPause() {
		super.onPause();
		if (null == Irekia.main_Overlord)
			return;
		if (Irekia.is_tablet) {
			Irekia.close_prev = true;
			Irekia.main_Overlord.child_items.deleteObserver(this);
		}
	}

	public void onResume() {
		super.onResume();
		if (null == Irekia.main_Overlord)
			return;
		if (Irekia.is_tablet) {
			Irekia.main_Overlord.set_progress_reporter(this);
			Irekia.main_Overlord.child_items.addObserver(this);
			if (!Irekia.isNetworkAvailable())
				findViewById(R.id.more_items_row_layout).setVisibility(View.GONE);
			update(null, null);
		}
	}

	/**
	 * Returns the currently viewed item.
	 */
	Gallery_item get_current_item() {
		final int pos = gallery.getSelectedItemPosition();
		if (Gallery.INVALID_POSITION != pos && pos >= 0 &&
			pos < Irekia.main_Overlord.child_items.size())
			return (Gallery_item) Irekia.main_Overlord.child_items.get(pos);

		return null;
	}

	/**
	 * Override the key down and route it to web back navigation.
	 *
	 * @return returns true if we did intercept the web view navigation otherwise
	 *         what super does.
	 */
	@Override
	public boolean onKeyDown(final int keyCode, final KeyEvent event) {
		final int direction = Irekia.handle_volume_keys(keyCode);
		if (0 != direction) {
			switch_item(direction);
			return true;
		}
		return super.onKeyDown(keyCode, event);
	}

	/**
	 * Handles nextStep/prev button clicks to change the current item.
	 */
	public void onClick(View v) {
		if (v == buttons.prev)
			switch_item(-1);
		else if (v == buttons.next)
			switch_item(+1);
	}

	/**
	 * Changes the current item to the previous or nextStep one.
	 *
	 * @param direction A positive or negative value, the function won't do
	 *                  anything if it is zero. The direction will move the item forward or backward
	 *                  through the overlord's list and animate a view flip.
	 *                  <p/>
	 *                  Even if no changes are done, this function calls buttons.update().
	 */
	private void switch_item(int direction) {
		if (null != Irekia.main_Overlord && 0 != direction) {
			Content_item new_item = null;
			if (direction < 0)
				new_item = Irekia.main_Overlord.get_prev_child(get_current_item());
			else if (direction > 0)
				new_item = Irekia.main_Overlord.get_next_child(get_current_item());

			// Ok, if the nextStep item is ok, flip to it.
			if (null != new_item && null != new_item.get_langcode_url()) {
				gallery.setSelection(gallery.getSelectedItemPosition() + direction);
			} else if (0 != direction && Irekia.volume_key_navigation) {
				// Looks like we reached a limit, tell the user.
				if (null == last_limit_toast)
					last_limit_toast = Toast.makeText(this,
						I18n.e(Embedded_string.VOLUME_LIST_LIMIT),
						Toast.LENGTH_SHORT);

				if (null != last_limit_toast) {
					last_limit_toast.cancel();
					last_limit_toast.show();
				}
			}
		}
		buttons.update(Irekia.main_Overlord, get_current_item());

		if (null != last_desc_toast)
			last_desc_toast.cancel();
	}

	/**
	 * Show the description of the image if the user touches it.
	 */
	@Override
	public void onItemClick(AdapterView<?> parent, View v, int position, long id) {
		if (null != last_desc_toast)
			last_desc_toast.cancel();

		Gallery_item item = get_current_item();

		last_desc_toast = Toast.makeText(this, item.title, Toast.LENGTH_SHORT);
		last_desc_toast.show();
	}

/********************************** Sharekit ********************************/

	/**
	 * The user pressed the menu button, create the share menu.
	 *
	 * @return returns always true, because we always intercept the action.
	 */
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.share_menu, menu);
		MenuItem newSearch = menu.findItem(R.id.new_search);
		if (null != newSearch)
			newSearch.setVisible(false);
		MenuItem settings = menu.findItem(R.id.settings);
		if (null != settings)
			settings.setVisible(Irekia.is_tablet);
		MenuItem about = menu.findItem(R.id.about);
		if (null != about)
			about.setVisible(Irekia.is_tablet);
		I18n.translate(menu);
		return true;
	}

	/**
	 * The user selected a menu option, what should we do?
	 *
	 * @return returns always true, because we always intercept the action.
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem menuitem) {
		Content_item item = get_current_item();
		if (null != item)
			Sharekit.share_item(this, menuitem.getItemId(), item);
		return true;
	}

	@Override
	public void set_progress(int progress) {
		if (Irekia.is_tablet)
			setCustomProgress(progress);
	}

	@Override
	public void update(Observable observable, Object o) {
		if (Irekia.is_tablet) {
			int scrollY = findViewById(R.id.parent_scroll).getScrollY();
			int scrollX = findViewById(R.id.parent_scroll).getScrollX();
			//If Overlord is able to fetch more items...
			if (Irekia.main_Overlord != null && Irekia.main_Overlord.last_selected_item != null
				&& Irekia.main_Overlord.last_selected_item.can_fetch_more()
				&& Irekia.main_Overlord.current_paginated_result.can_fetch_more()
				&& Irekia.main_Overlord.last_selected_item.has_older) {
				findViewById(R.id.more_items_row_layout).setVisibility(View.VISIBLE);
				//Change_more_items_row state
				findViewById(R.id.more_items_row_layout).findViewById(R.id.items_loading_spinner).setVisibility(View.GONE);
				((TextView) findViewById(R.id.more_items_row_layout).findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.MORE_ITEMS));
				findViewById(R.id.more_items_row_layout).setClickable(true);
			}
			grid_adapter.set_items(Irekia.main_Overlord.child_items);
			grid_adapter.notifyDataSetChanged();
			adapter.set_items(Irekia.main_Overlord.child_items);
			adapter.notifyDataSetChanged();
			findViewById(R.id.parent_scroll).scrollTo(scrollX, scrollY);
		}
	}
}
