package net.efaber.irekia.childcontroller;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.*;
import android.view.animation.AnimationUtils;
import android.widget.*;
import com.github.droidfu.widgets.WebImageView;
import net.efaber.irekia.*;
import net.efaber.irekia.activities.About_activity;
import net.efaber.irekia.activities.Restarter_activity;
import net.efaber.irekia.models.Activity_progress;
import net.efaber.irekia.models.Content_item;
import net.efaber.irekia.models.News_item;
import net.efaber.irekia.models.Section_state;
import net.efaber.irekia.news.News_data;
import net.efaber.irekia.video.Video_player_activity;
import smartlistadapter.SmartList;

import java.text.ParseException;
import java.util.Observable;
import java.util.Observer;

public class Child_video_facade_activity extends Irekia_default_activity
	implements View.OnClickListener, AdapterView.OnItemClickListener, Observer, Activity_progress, ExpandableListView.OnChildClickListener {

	/// Points to the layout's view flipper.
	private ViewFlipper flipper;
	/// Holds pointers to both web views inside the view flipper.
	private ListView first_list, second_list;
	/// Pair of adapters and their respective backing arrays.
	private Video_adapter first_adapter, second_adapter;

	/// The buttons used to navigate news. Might be hidden.
	private Navigation_buttons buttons;

	/// The item itself, we extract the URL from it and use it to share.
	private Content_item item;

	/// Points to the previous limit warning toast, to avoid spamming the user.
	private Toast last_limit_toast;

	/// Minimum speed of the swipe to be accepted as a valid fling gesture.
	private float swipe_threshold = 1000;
	/// Minimum finger distance traveled to accept flings.
	private float swipe_distance = 1000;

	/// Our gesture detector.
	private final GestureDetector mGestureDetector =
		new GestureDetector(new Custom_fling_detector());
	private Child_news_adapter adapter = null;

	/**
	 * Called when the activity is first created.
	 */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.video_facade);
		getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.title);
		setCustomProgressBarIndeterminateVisibility(false);
		setCustomProgressBarVisibility(false);
		findViewById(R.id.title_icon_back).setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {
				if (Irekia.main_Overlord != null)
					Irekia.main_Overlord.go_home(Child_video_facade_activity.this);
			}
		});

		// Calibrate flick gestures according to the device's resolution.
		final ViewConfiguration vc = ViewConfiguration.get(this);
		swipe_threshold = vc.getScaledMinimumFlingVelocity();
		swipe_distance = getResources().getDisplayMetrics().xdpi * 0.70f;
		if (Irekia.is_tablet)
			Irekia.main_Overlord.set_progress_reporter(this);
		// Set up GUI and connect handlers.
		flipper = (ViewFlipper) findViewById(R.id.flipper);
		first_list = (ListView) findViewById(R.id.first_list);
		first_list.setOnItemClickListener(this);
		first_adapter = new Video_adapter(this);
		first_list.setAdapter(first_adapter);
		second_list = (ListView) findViewById(R.id.second_list);
		second_list.setOnItemClickListener(this);
		second_adapter = new Video_adapter(this);
		second_list.setAdapter(second_adapter);
		buttons = new Navigation_buttons(this, this);

		// Hide the buttons if the user enabled hardware key navigation.
		if (Irekia.volume_key_navigation) {
			LinearLayout button_layout =
				(LinearLayout) findViewById(R.id.button_layout);
			if (null != button_layout)
				button_layout.setVisibility(View.GONE);
		}

		// Caller dependant setup through parameters.
		load_params();
		if (Irekia.is_tablet)
			initParentList();

	}

	private ExpandableListView l = null;

	private void initParentList() {
		l = (ExpandableListView) findViewById(android.R.id.list);
		l.setChildDivider(getResources().getDrawable(R.color.r_light_gray));
		l.setDivider(getResources().getDrawable(R.color.r_light_gray));
		l.setDividerHeight((int) (Irekia.density + 0.5f));
		l.setGroupIndicator(getResources().getDrawable(R.drawable.empty_expandable));
		News_data news_data = null;
		try {
			if (Irekia.main_Overlord.previous_child_items.peek() != null && Irekia.main_Overlord.previous_child_items.peek().getRoot_item() != null)
				news_data = new News_data(Irekia.main_Overlord.previous_child_items.peek().getRoot_item().data);
			else
				news_data = new News_data(Irekia.main_Overlord.generic_news_data);
		} catch (ParseException e) {
			e.printStackTrace();
			return;
		}
		adapter = new Child_news_adapter(this, news_data);
		//Create more_items_row to allow user to ask for new items

		final View more_items_row = getLayoutInflater().inflate(R.layout.load_more_items, null);
		((TextView) more_items_row.findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.MORE_ITEMS));
		more_items_row.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {
				//Change more_items_row state to show loading spinner
				more_items_row.findViewById(R.id.items_loading_spinner).setVisibility(View.VISIBLE);
				((TextView) more_items_row.findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.DOWNLOADING_DATA));
				//Avoid asking for more items until last search is ended
				more_items_row.setClickable(false);
				//Fetch more child items
				Irekia.main_Overlord.fetch_more_child();
			}
		});

		adapter.set(Irekia.main_Overlord);
		//if Overlord current result can fetch more items Add more_items_row
		if (Irekia.main_Overlord != null && Irekia.main_Overlord.current_paginated_result.can_fetch_more()) {
			l.addFooterView(more_items_row);
			more_items_row.setVisibility(View.VISIBLE);

		} else
			//Update more_items_row visibility
			more_items_row.setVisibility(View.GONE);
		l.setAdapter(adapter);
		l.setOnGroupCollapseListener(adapter);
		l.setOnGroupExpandListener(adapter);
		// Configure some looks for the listview.
		findViewById(R.id.main_layout).setBackgroundColor(news_data.back_normal_color);
		l.setBackgroundColor(news_data.back_normal_color);
		l.setDrawingCacheBackgroundColor(news_data.back_normal_color);
		l.setCacheColorHint(news_data.back_normal_color);
		registerForContextMenu(l);
		l.setOnChildClickListener(this);
	}

	@Override
	protected void onRestart() {
		super.onRestart();
		//peek previous volatiles items for navigating (prev and nextStep)
		if (Irekia.main_Overlord != null && Irekia.main_Overlord.previous_child_items != null && Irekia.main_Overlord.previous_child_items.size() > 0) {
			Irekia.main_Overlord.current_paginated_result = Irekia.main_Overlord.previous_child_items.peek();
			Irekia.main_Overlord.child_items.replace(new SmartList<Content_item>(Irekia.main_Overlord.current_paginated_result.getCurrent_items()));
		}
	}

	@Override
	public void onResume() {
		super.onResume();
		if (Irekia.main_Overlord == null)
			return;
		if (Irekia.is_tablet) {
			Irekia.main_Overlord.set_progress_reporter(this);
			Irekia.main_Overlord.child_items.addObserver(this);
			update(null, null);
		}
	}


	@Override
	public void onPause() {
		super.onPause();
		if (Irekia.main_Overlord == null)
			return;
		if (Irekia.is_tablet) {
			Irekia.close_prev = true;
			Irekia.main_Overlord.child_items.deleteObserver(this);
		}
	}

	@Override
	public void update(Observable observable, Object o) {
		if (Irekia.is_tablet) {
			if (Irekia.main_Overlord == null)
				return;
			adapter.set(Irekia.main_Overlord);
			l.setVisibility(View.VISIBLE);
			View more_items = findViewById(R.id.more_items_row_layout);
			//If current result has not more results hide more_items_row
			if (more_items != null) {
				if (Irekia.main_Overlord != null && Irekia.main_Overlord.last_selected_item != null
					&& Irekia.main_Overlord.last_selected_item.can_fetch_more()
					&& Irekia.main_Overlord.current_paginated_result.can_fetch_more()
					&& Irekia.main_Overlord.last_selected_item.has_older) {
					more_items.findViewById(R.id.items_loading_spinner).setVisibility(View.GONE);
					more_items.findViewById(R.id.more_items_row_layout).setVisibility(View.GONE);
					more_items.findViewById(R.id.items_loading_spinner).setVisibility(View.GONE);
					((TextView) more_items.findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.MORE_ITEMS));
					more_items.setClickable(false);
				} else {
					more_items.findViewById(R.id.more_items_row_layout).setVisibility(View.VISIBLE);
					more_items.findViewById(R.id.items_loading_spinner).setVisibility(View.GONE);
					((TextView) more_items.findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.MORE_ITEMS));
				}
			}
			update_collapsed_state(l, adapter);
		}
	}

	@Override
	public boolean onChildClick(ExpandableListView parent, View view, int groupPosition, int childPosition, long id) {
		if (Irekia.is_tablet) {
			item = (News_item) parent.getExpandableListAdapter().getChild(
				groupPosition, childPosition);
			flipper.setInAnimation(AnimationUtils.loadAnimation(this,
				R.anim.slide_in_left));
			flipper.setOutAnimation(AnimationUtils.loadAnimation(this,
				R.anim.slide_out_right));
			if (null != item && !item.get_langcode_url().equals("")) {
				setTitle("Irekia: " + item.title);
				buttons.update_child(Irekia.main_Overlord, item);
				((Video_adapter) hidden_list().getAdapter()).set_item(item);
				setTitle(item.title);
				flipper.showNext();
				save_params();
			}
			return true;
		}
		return false;
	}

	@Override
	public void set_progress(int progress) {
		if (Irekia.is_tablet)
			setCustomProgress(progress);
	}

	protected void update_collapsed_state(ExpandableListView list,
										  Child_news_adapter adapter) {
		for (int f = 0; f < adapter.getGroupCount(); f++) {
			Section_state section = adapter.getGroup(f);
			if (null != section) {
				if (section.collapsed)
					list.collapseGroup(f);
				else
					list.expandGroup(f);
			} else {
				list.expandGroup(f);
			}
		}
	}

	/**
	 * Pass some parameters to our future self after rotation.
	 * We actually do this through the intent.
	 */
	@Override
	public Object onRetainNonConfigurationInstance() {
		save_params();
		return null;
	}

	/**
	 * Loads the parameters for the web view from the bundle.
	 * This method will fill the attributes overlord and item or leave them as
	 * null.  It also sets the title of the activity, breadcrumb style. Call this
	 * method after the interface has been set up, since this updates the state of
	 * the navigation buttons.
	 */
	private void load_params() {
		item = null;

		if (Irekia.main_Overlord != null && Irekia.main_Overlord.previous_child_items != null && Irekia.main_Overlord.previous_child_items.size() > 0) {
			Irekia.main_Overlord.current_paginated_result = Irekia.main_Overlord.previous_child_items.peek();
			Irekia.main_Overlord.child_items.replace(new SmartList<Content_item>(Irekia.main_Overlord.current_paginated_result.getCurrent_items()));
		}
		Bundle extras = getIntent().getExtras();
		String title = extras.getString(Irekia.TITLE_PARAM);
		if (null != title)
			setTitle("Irekia: " + title);

		if (null != Irekia.main_Overlord && Irekia.main_Overlord.last_selected_item != null)
			item = Irekia.main_Overlord.last_selected_item;

		((Video_adapter) visible_list().getAdapter()).set_item(item);
		buttons.update(Irekia.main_Overlord, item);
	}

	/**
	 * Inverse version of load_params(), call it before rotation or so.
	 * In fact, you should call this whenever the content changes, since you really
	 * don't know when you are going to be killed by the grim reaper to be reborn
	 * later.
	 */
	private void save_params() {
		Bundle extras = getIntent().getExtras();
		extras.remove(Irekia.CONTENT_ID_PARAM);

		if (null != item)
			extras.putInt(Irekia.CONTENT_ID_PARAM, item.id);
		getIntent().putExtras(extras);
	}

	/**
	 * Small helper to get the currently viewed web view.
	 *
	 * @return the WebView object, could be null.
	 */
	private ListView visible_list() {
		if (flipper.getCurrentView() == first_list)
			return first_list;
		else
			return second_list;
	}

	/**
	 * Small helper to get the currently hidden web view.
	 *
	 * @return the WebView object, could be null.
	 */
	private ListView hidden_list() {
		if (flipper.getCurrentView() == first_list)
			return second_list;
		else
			return first_list;
	}

	/**
	 * Changes the current item to the previous or nextStep one.
	 *
	 * @param direction A positive or negative value, the function won't do
	 *                  anything if it is zero. The direction will move the item forward or backward
	 *                  through the overlord's list and animate a view flip.
	 *                  <p/>
	 *                  Even if no changes are done, this function calls buttons.update().
	 */
	private void switch_item(int direction) {
		if (null != Irekia.main_Overlord && 0 != direction) {
			Content_item new_item = null;
			if (direction < 0) {
				flipper.setInAnimation(AnimationUtils.loadAnimation(this,
					R.anim.slide_in_left));
				flipper.setOutAnimation(AnimationUtils.loadAnimation(this,
					R.anim.slide_out_right));
				//flipper.showPrevious();
				new_item = Irekia.main_Overlord.get_prev_child(item);
			} else if (direction > 0) {
				flipper.setInAnimation(AnimationUtils.loadAnimation(this,
					R.anim.slide_in_right));
				flipper.setOutAnimation(AnimationUtils.loadAnimation(this,
					R.anim.slide_out_left));
				//flipper.showNext();
				new_item = Irekia.main_Overlord.get_next_child(item);
			}

			// Ok, if the nextStep item is ok, flip to it.
			if (null != new_item && !new_item.get_langcode_url().equals("")) {
				item = new_item;
				((Video_adapter) hidden_list().getAdapter()).set_item(item);
				setTitle(item.title);
				flipper.showNext();
				save_params();
			} else if (0 != direction && Irekia.volume_key_navigation) {
				// Looks like we reached a limit, tell the user.
				if (null == last_limit_toast)
					last_limit_toast = Toast.makeText(this,
						I18n.e(I18n.Embedded_string.VOLUME_LIST_LIMIT),
						Toast.LENGTH_SHORT);

				if (null != last_limit_toast) {
					last_limit_toast.cancel();
					last_limit_toast.show();
				}
			}
		}
		buttons.update(Irekia.main_Overlord, item);
	}

	/**
	 * Override the key down and route it to web back navigation.
	 *
	 * @return returns true if we did intercept the web view navigation otherwise
	 *         what super does.
	 */
	@Override
	public boolean onKeyDown(final int keyCode, final KeyEvent event) {
		final int direction = Irekia.handle_volume_keys(keyCode);
		if (0 != direction) {
			switch_item(direction);
			return true;
		}
		return super.onKeyDown(keyCode, event);
	}

	/**
	 * The user touched a cell.
	 * We want to discard touches on the top cell, the bottom cell will play back
	 * the video.
	 */
	public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
		if (1 != position || null == item)
			return;

		// Ugly hack here to detect video items.
		Intent intent = new Intent(this, Video_player_activity.class);
		intent.putExtra(Video_player_activity.IOS_URL_PARAM, item.get_langcode_url());
		if (null != item.data)
			intent.putExtra(Video_player_activity.PROGRESSIVE_URL_PARAM,
				item.data.get_url("progressive_file", null));

		startActivity(intent);
	}

	/**
	 * Handles nextStep/prev button clicks to change the current item.
	 */
	public void onClick(View v) {
		if (v == buttons.prev)
			switch_item(-1);
		else if (v == buttons.next)
			switch_item(+1);
	}

	/**
	 * Hook touch events and delegate them to our custom fling class.
	 */
	@Override
	public boolean dispatchTouchEvent(MotionEvent e) {
		super.dispatchTouchEvent(e);
		return mGestureDetector.onTouchEvent(e);
	}

	/****************************************************************************/

	/**
	 * Implements fling detection on the webviews.
	 */
	private class Custom_fling_detector
		extends GestureDetector.SimpleOnGestureListener {
		public boolean onFling(MotionEvent e1, MotionEvent e2, float vX, float vY) {
			final float abs_v = Math.abs(vX);
			if (abs_v > Math.abs(vY)) {
				// Filtered horizontal movement.
				if (abs_v > swipe_threshold &&
					Math.abs(e1.getX() - e2.getX()) > swipe_distance) {
					final boolean fling_to_right = vX > 0;
					if (fling_to_right)
						switch_item(-1);
					else
						switch_item(+1);
					return true;
				}
			}
			return false;
		}

	}

	/********************************** Sharekit ********************************/

	/**
	 * The user pressed the menu button, create the share menu.
	 *
	 * @return returns always true, because we always intercept the action.
	 */
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.share_menu, menu);
		MenuItem newSearch = menu.findItem(R.id.new_search);
		if (null != newSearch)
			newSearch.setVisible(false);
		MenuItem settings = menu.findItem(R.id.settings);
		if (null != settings)
			settings.setVisible(Irekia.is_tablet);
		MenuItem about = menu.findItem(R.id.about);
		if (null != about)
			about.setVisible(Irekia.is_tablet);
		I18n.translate(menu);
		return true;
	}

	/**
	 * The user selected a menu option, what should we do?
	 *
	 * @return returns always true, because we always intercept the action.
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem menuitem) {
		switch (menuitem.getItemId()) {
			case R.id.send_by_mail: {
				if (null != item)
					Sharekit.share_item(this, menuitem.getItemId(), item);
			}
			;
			break;
			case R.id.twitter: {
				if (null != item)
					Sharekit.share_item(this, menuitem.getItemId(), item);
			}
			;
			break;
			case R.id.facebook: {
				if (null != item)
					Sharekit.share_item(this, menuitem.getItemId(), item);
			}
			;
			break;
			case R.id.about: {
				Intent intent = new Intent(this, About_activity.class);
				startActivity(intent);
			}
			break;
			case R.id.settings: {
				Activity_options.onOptionsItemSelected(this, menuitem, Irekia.main_Overlord);
			}
			break;
		}
		return true;
	}

	private static final int SETTINGS_REQUEST_CODE = 11235;


	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if (SETTINGS_REQUEST_CODE == requestCode) {
			if (Irekia.update_shared_preferences(this, true)) {
				// Force clearing the overlords to make Tab_activity reload all.
				Irekia.main_Overlord = null;
				Intent intent = new Intent(this, Restarter_activity.class);
				startActivity(intent);
				finish();
			}
		}
	}

	/****************************************************************************/

	/**
	 * Implements a fake video adapter on top of the selected item.
	 */
	private class Video_adapter extends BaseAdapter
		implements ListAdapter {
		/// The item we have to show.
		private News_item item;

		/// Extracted configuration data for the video item.
		private String preview_url;
		private int title_color, text_color;
		private float preview_width, preview_height, padding, title_size, text_size;

		/// Store pointer to context to be able to create widgets.
		private Context context;

		public Video_adapter(Context context) {
			super();
			this.context = context;
		}

		/// Sets and refreshes the parent list with the contents.
		public void set_item(Content_item item) {
			if (News_item.class.isInstance(item)) {
				this.item = (News_item) item;
				preview_url = item.image;
				// Extract video data from the item.
				if (null != item.data) {
					preview_url = item.data.get_url("preview_url", item.image);
					preview_width = item.data.get_int("preview_width", 285);
					preview_width = Math.max(30, Math.min(285, preview_width));
					preview_height = item.data.get_int("preview_width", 160);
					preview_height = Math.max(30, Math.min(160, preview_height));
					padding = item.data.get_int("padding", 3);
					title_size = item.data.get_int("title_size", 16);
					title_color = item.data.get_color("title_color", Colors.blue);
					text_size = item.data.get_int("text_size", 13);
					text_color = item.data.get_int("text_color", Colors.black);
					// Scale everything to final pixel sizes.
					preview_width *= Irekia.density;
					preview_height *= Irekia.density;
					padding *= Irekia.density;
					title_size *= Irekia.density;
					text_size *= Irekia.density;
				}
			} else {
				this.item = null;
				preview_url = null;
			}

			notifyDataSetChanged();
		}

		@Override
		public int getCount() {
			return (null == item) ? 0 : 2;
		}

		@Override
		public Object getItem(int position) {
			return item;
		}

		@Override
		public long getItemId(int position) {
			return position;
		}

		@Override
		public int getItemViewType(int position) {
			return position;
		}

		@Override
		public View getView(int position, View convertView, ViewGroup parent) {
			if (null == item) {
				TextView t = new TextView(context);
				t.setText("Position " + position);
				return t;
			}

			if (position < 1) {
				View cell = LayoutInflater.from(context).inflate(
					R.layout.video_text_cell, null);
				TextView title = (TextView) cell.findViewById(R.id.title);
				TextView subtitle = (TextView) cell.findViewById(R.id.subtitle);
				title.setText(item.title);
				title.setTextColor(title_color);
				title.setTextSize(title_size);
				if (null != item.footer)
					subtitle.setText(item.footer);
				else
					subtitle.setText("");
				subtitle.setTextColor(text_color);
				subtitle.setTextSize(text_size);
				return cell;
			} else {
				View cell = LayoutInflater.from(context).inflate(
					R.layout.video_thumb_cell, null);
				WebImageView w = (WebImageView) cell.findViewById(R.id.image);
				w.setNoImageDrawable(R.drawable.video_loading);
				//ImageView i = (ImageView)w.getChildAt(1);
				//i.setScaleType(ImageView.ScaleType.FIT_XY);
				// This is quite wrong.
				//i.setImageDrawable(
				//getResources().getDrawable(R.drawable.video_loading));

				w.setImageUrl(preview_url);
				w.loadImage();
				return cell;
			}
		}

		@Override
		public int getViewTypeCount() {
			return 2;
		}

		@Override
		public boolean hasStableIds() {
			return true;
		}

		@Override
		public boolean isEmpty() {
			return null == item;
		}

		/**
		 * We don't want all cells in the video facade to be selectable.
		 */
		@Override
		public boolean areAllItemsEnabled() {
			return false;
		}

		/**
		 * Tells that only the thumbnail cell has interaction.
		 */
		@Override
		public boolean isEnabled(int position) {
			return position > 0;
		}

	}

}
