//
// OpenIrekia v2.0 Cliente Android
//
// Copyright 2009-2011 eFaber, S.L.
// Copyright 2009-2011 Ejie, S.A.
// Copyrigth 2009-2011 Dirección de Gobierno Abierto y Comunicación en Internet; 
//    Gobernu Irekirako eta Interneteko Komunikaziorako Zuzendaritza; Lehendakaritza.
//    Gobierno Vasco – Eusko Jaurlaritza 
// Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas 
// por la Comisión Europea– versiones posteriores de la EUPL (la Licencia);
// Solo podrá usarse esta obra si se respeta la Licencia. Puede obtenerse una 
// copia de la Licencia en: http://ec.europa.eu/idabc/eupl 
// Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
// el programa distribuido con arreglo a la Licencia se distribuye TAL CUAL,
// SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
// Véase la Licencia en el idioma concreto que rige los permisos y limitaciones 
// que establece la Licencia
//
//  http://open.irekia.net, openirekia@efaber.net

package net.efaber.irekia.childcontroller;

import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Intent;
import android.os.Bundle;
import android.view.*;
import android.view.animation.AnimationUtils;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.widget.*;
import net.efaber.irekia.*;
import net.efaber.irekia.I18n.Embedded_string;
import net.efaber.irekia.activities.About_activity;
import net.efaber.irekia.activities.Restarter_activity;
import net.efaber.irekia.activities.Settings_activity;
import net.efaber.irekia.login.Login_web_activity;
import net.efaber.irekia.models.Activity_progress;
import net.efaber.irekia.models.Content_item;
import net.efaber.irekia.models.News_item;
import net.efaber.irekia.models.Section_state;
import net.efaber.irekia.news.News_data;
import net.efaber.irekia.social.Social_Activity;
import smartlistadapter.SmartList;

import java.text.ParseException;
import java.util.Observable;
import java.util.Observer;

public class Child_web_activity extends Irekia_default_activity
	implements View.OnClickListener, Runnable, Social_Activity, Observer, Activity_progress, ExpandableListView.OnChildClickListener {
	/// Points to the layout's view flipper.
	private ViewFlipper flipper;
	/// Holds pointers to both web views inside the view flipper.
	private WebView first_webview, second_webview;
	/// The buttons used to navigate news. Might be hidden.
	private Navigation_buttons buttons;

	/// The item itself, we extract the URL from it and use it to share.
	private Content_item item;

	/// Points to the previous limit warning toast, to avoid spamming the user.
	private Toast last_limit_toast;

	/// Minimum speed of the swipe to be accepted as a valid fling gesture.
	private float swipe_threshold = 1000;
	/// Minimum finger distance traveled to accept flings.
	private float swipe_distance = 1000;

	/// Our gesture detector.
	private final GestureDetector mGestureDetector =
		new GestureDetector(new Custom_fling_detector());
	private final int CACHE_MODE = Irekia.isNetworkAvailable() ? WebSettings.LOAD_CACHE_ELSE_NETWORK : WebSettings.LOAD_CACHE_ONLY;
	private ProgressDialog progressDialog;
	private Web_view_client web_view_client;
	private Child_news_adapter adapter = null;

	/**
	 * Called when the activity is first created.
	 */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.webview);
		getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.title_refresh);
		setTitle(R.string.app_name);
		setCustomProgressBarIndeterminateVisibility(true);
		setCustomProgressBarVisibility(true);
		findViewById(R.id.title_icon).setVisibility(View.GONE);
		ImageButton homeBtn = (ImageButton) findViewById(R.id.title_icon_back);
		homeBtn.setVisibility(View.VISIBLE);
		homeBtn.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {
				if (Irekia.main_Overlord != null)
					Irekia.main_Overlord.go_home(Child_web_activity.this);
			}
		});
		findViewById(R.id.top_refresh).setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {
				visible_web().reload();
			}
		});
		progressDialog = new ProgressDialog(this);
		progressDialog.setCancelable(false);
		// Calibrate flick gestures according to the device's resolution.
		final ViewConfiguration vc = ViewConfiguration.get(this);
		swipe_threshold = vc.getScaledMinimumFlingVelocity();
		swipe_distance = getResources().getDisplayMetrics().xdpi * 0.70f;
		this.web_view_client = new Web_view_client(this, false);
		// Set up GUI and connect handlers.
		flipper = (ViewFlipper) findViewById(R.id.flipper);
		first_webview = (WebView) findViewById(R.id.first_webview);
		first_webview.setWebViewClient(this.web_view_client);
		first_webview.getSettings().setJavaScriptEnabled(true);
		first_webview.getSettings().setPluginsEnabled(true);
		//Settings for news caching purposes

		first_webview.getSettings().setAppCacheMaxSize(1024 * 1024 * 8);
		first_webview.getSettings().setAppCachePath(Irekia.cache_dir);
		first_webview.getSettings().setDomStorageEnabled(true);
		first_webview.getSettings().setAllowFileAccess(true);
		first_webview.getSettings().setAppCacheEnabled(true);
		first_webview.getSettings().setCacheMode(CACHE_MODE);
		first_webview.getSettings().setUserAgentString("Irekia/3.0");
		second_webview = (WebView) findViewById(R.id.second_webview);
		second_webview.getSettings().setJavaScriptEnabled(true);
		second_webview.getSettings().setPluginsEnabled(true);
		//Settings for news caching purposes
		second_webview.getSettings().setAppCacheMaxSize(1024 * 1024 * 8);
		second_webview.getSettings().setAppCachePath(Irekia.cache_dir);
		second_webview.getSettings().setDomStorageEnabled(true);
		second_webview.getSettings().setAllowFileAccess(true);
		second_webview.getSettings().setAppCacheEnabled(true);
		second_webview.getSettings().setCacheMode(CACHE_MODE);
		second_webview.getSettings().setUserAgentString("Irekia/3.0");
		second_webview.setWebViewClient(this.web_view_client);
		buttons = new Navigation_buttons(this, this);
		first_webview.setWebChromeClient(new Web_chrome_client());
		second_webview.setWebChromeClient(new Web_chrome_client());

		// Hide the buttons if the user enabled hardware key navigation.
		if (Irekia.volume_key_navigation) {
			LinearLayout button_layout =
				(LinearLayout) findViewById(R.id.button_layout);
			if (null != button_layout)
				button_layout.setVisibility(View.GONE);
		}

		// Caller dependant setup through parameters.
		load_params();

		if (null == savedInstanceState) {
			if (null != item && !item.get_langcode_url().equals(""))
				visible_web().loadUrl(item.get_langcode_url());
		} else {
			visible_web().restoreState(savedInstanceState);
		}

		if (Irekia.is_tablet)
			initParentList();

	}

	private ExpandableListView l = null;

	private void initParentList() {
		l = (ExpandableListView) findViewById(android.R.id.list);
		l.setChildDivider(getResources().getDrawable(R.color.r_light_gray));
		l.setDivider(getResources().getDrawable(R.color.r_light_gray));
		l.setDividerHeight((int) (Irekia.density + 0.5f));
		l.setGroupIndicator(getResources().getDrawable(R.drawable.empty_expandable));
		News_data news_data = null;
		try {
			if (Irekia.main_Overlord.last_selected_item.data != null)
				news_data = new News_data(Irekia.main_Overlord.last_selected_item.data);
			else
				news_data = new News_data(Irekia.main_Overlord.generic_news_data);
		} catch (ParseException e) {
			e.printStackTrace();
			return;
		}
		adapter = new Child_news_adapter(this, news_data);
		//Create more_items_row to allow user to ask for new items

		final View more_items_row = getLayoutInflater().inflate(R.layout.load_more_items, null);
		((TextView) more_items_row.findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.MORE_ITEMS));
		more_items_row.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {
				//Change more_items_row state to show loading spinner
				more_items_row.findViewById(R.id.items_loading_spinner).setVisibility(View.VISIBLE);
				((TextView) more_items_row.findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.DOWNLOADING_DATA));
				//Avoid asking for more items until last search is ended
				more_items_row.setClickable(false);
				//Fetch more child items
				Irekia.main_Overlord.fetch_more_child();
			}
		});

		adapter.set(Irekia.main_Overlord);
		//if Overlord current result can fetch more items Add more_items_row
		if (Irekia.main_Overlord != null && Irekia.main_Overlord.last_selected_item != null && Irekia.main_Overlord.last_selected_item.can_fetch_more()
			&& Irekia.main_Overlord.current_paginated_result.can_fetch_more()) {
			l.addFooterView(more_items_row);
			more_items_row.setVisibility(View.VISIBLE);

		} else
			//Update more_items_row visibility
			more_items_row.setVisibility(View.GONE);
		l.setAdapter(adapter);
		l.setOnGroupCollapseListener(adapter);
		l.setOnGroupExpandListener(adapter);
		// Configure some looks for the listview.
		findViewById(R.id.main_layout).setBackgroundColor(news_data.back_normal_color);
		l.setBackgroundColor(news_data.back_normal_color);
		l.setDrawingCacheBackgroundColor(news_data.back_normal_color);
		l.setCacheColorHint(news_data.back_normal_color);
		registerForContextMenu(l);
		l.setOnChildClickListener(this);
	}

	@Override
	protected void onRestart() {
		super.onRestart();
		//peek previous childs items for navigating (prev and nextStep)
		if (Irekia.main_Overlord != null && Irekia.main_Overlord.previous_child_items != null && Irekia.main_Overlord.previous_child_items.size() > 0) {
			Irekia.main_Overlord.current_paginated_result = Irekia.main_Overlord.previous_child_items.peek();
			Irekia.main_Overlord.child_items.replace(new SmartList<Content_item>(Irekia.main_Overlord.current_paginated_result.getCurrent_items()));
		}
	}

	@Override
	public void onResume() {
		super.onResume();
		if (Irekia.main_Overlord == null)
			return;
		if (Irekia.is_tablet) {
			if (item != null)
				this.web_view_client.set_item(item);
			Irekia.main_Overlord.set_progress_reporter(this);
			Irekia.main_Overlord.child_items.addObserver(this);
			update(null, null);
		}
	}

	@Override
	public void onPause() {
		super.onPause();
		if (Irekia.main_Overlord == null)
			return;
		if (Irekia.is_tablet) {
			Irekia.close_prev = true;
			Irekia.main_Overlord.child_items.deleteObserver(this);
		}
	}

	/**
	 * Called before killing the activity. Try to save web contents.
	 */
	@Override
	protected void onSaveInstanceState(Bundle outState) {
		visible_web().saveState(outState);
	}

	/**
	 * Pass some parameters to our future self after rotation.
	 * We actually do this through the intent.
	 */
//	@Override
//	public Object onRetainNonConfigurationInstance() {
//		save_params();
//		return null;
//	}

	/**
	 * Loads the parameters for the web view from the bundle.
	 * This method will fill the attributes overlord and item or leave them as
	 * null.  It also sets the title of the activity, breadcrumb style. Call this
	 * method after the interface has been set up, since this updates the state of
	 * the navigation buttons.
	 */
	private void load_params() {
		item = null;

		Bundle extras = getIntent().getExtras();
		String title = extras.getString(Irekia.TITLE_PARAM);
		if (null != title)
			setTitle("Irekia: " + title);

		if (null != Irekia.main_Overlord)
			item = Irekia.main_Overlord.get_child_item(extras.getInt(Irekia.CONTENT_ID_PARAM, -1));
		this.web_view_client.set_item(item);
		buttons.update_child(Irekia.main_Overlord, item);
	}

	/**
	 * Inverse version of load_params(), call it before rotation or so.
	 * In fact, you should call this whenever the content changes, since you really
	 * don't know when you are going to be killed by the grim reaper to be reborn
	 * later.
	 */
	private void save_params() {
		Bundle extras = getIntent().getExtras();
		extras.remove(Irekia.CONTENT_ID_PARAM);

		if (null != item)
			extras.putInt(Irekia.CONTENT_ID_PARAM, item.id);
		getIntent().putExtras(extras);
	}

	/**
	 * Small helper to get the currently viewed web view.
	 *
	 * @return the WebView object, could be null.
	 */
	private WebView visible_web() {
		if (flipper.getCurrentView() == first_webview)
			return first_webview;
		else
			return second_webview;
	}

	/**
	 * Small helper to get the currently hidden web view.
	 *
	 * @return the WebView object, could be null.
	 */
	private WebView hidden_web() {
		if (flipper.getCurrentView() == first_webview)
			return second_webview;
		else
			return first_webview;
	}

	/**
	 * Changes the current item to the previous or nextStep one.
	 *
	 * @param direction A positive or negative value, the function won't do
	 *                  anything if it is zero. The direction will move the item forward or backward
	 *                  through the overlord's list and animate a view flip.
	 *                  <p/>
	 *                  Even if no changes are done, this function calls buttons.update().
	 */


	private void switch_item(int direction) {
//		Hack to know if current item is a list child or just unique_child_type item
		if (item.share_url == null || item.share_url.equals(""))
			return;
		if (null != Irekia.main_Overlord && 0 != direction) {
			Content_item new_item = null;
			if (direction < 0) {
				flipper.setInAnimation(AnimationUtils.loadAnimation(this,
					R.anim.slide_in_left));
				flipper.setOutAnimation(AnimationUtils.loadAnimation(this,
					R.anim.slide_out_right));
				//flipper.showPrevious();
				new_item = Irekia.main_Overlord.get_prev_child(item);
			} else if (direction > 0) {
				flipper.setInAnimation(AnimationUtils.loadAnimation(this,
					R.anim.slide_in_right));
				flipper.setOutAnimation(AnimationUtils.loadAnimation(this,
					R.anim.slide_out_left));
				//flipper.showNext();
				new_item = Irekia.main_Overlord.get_next_child(item);
			}

			// Ok, if the nextStep item is ok, flip to it.
			if (null != new_item && !new_item.get_langcode_url().equals("")) {
				hidden_web().clearHistory();
				hidden_web().loadUrl(new_item.get_langcode_url());
				item = new_item;
				this.web_view_client.set_item(item);
				setTitle("Irekia: " + item.title);
				flipper.showNext();
				// Enqueue removing content from the hidden view.
				flipper.postDelayed(this, 200);
				save_params();
			} else if (0 != direction && Irekia.volume_key_navigation) {
				// Looks like we reached a limit, tell the user.
				if (null == last_limit_toast)
					last_limit_toast = Toast.makeText(this,
						I18n.e(Embedded_string.VOLUME_LIST_LIMIT),
						Toast.LENGTH_SHORT);

				if (null != last_limit_toast) {
					last_limit_toast.cancel();
					last_limit_toast.show();
				}
			}
		}
		buttons.update_child(Irekia.main_Overlord, item);
	}

	/**
	 * Method implementing the Runnable interface for the onClick future.
	 * This simply resets the hidden web view to empty, so it doesn't show up with
	 * stale content when the user flips to a new view.
	 */
	public void run() {
		WebView view = hidden_web();
		if (null != view) {
			view.clearHistory();
			view.clearView();
		}
	}

	/**
	 * Override the key down and route it to web back navigation.
	 *
	 * @return returns true if we did intercept the web view navigation otherwise
	 *         what super does.
	 */
	@Override
	public boolean onKeyDown(final int keyCode, final KeyEvent event) {
		final int direction = Irekia.handle_volume_keys(keyCode);
		if (0 != direction) {
			switch_item(direction);
			return true;
		}
		return super.onKeyDown(keyCode, event);
	}

	/**
	 * Handles nextStep/prev button clicks to change the current item.
	 */
	public void onClick(View v) {
		if (v == buttons.prev)
			switch_item(-1);
		else if (v == buttons.next)
			switch_item(+1);
	}

	/**
	 * Hook touch events and delegate them to our custom fling class.
	 */
	@Override
	public boolean dispatchTouchEvent(MotionEvent e) {
		super.dispatchTouchEvent(e);
		return mGestureDetector.onTouchEvent(e);
	}

	@Override
	public void cancelDialog() {
		if (this.progressDialog.isShowing())
			this.progressDialog.cancel();
	}

	@Override
	public void showDialog(String message) {
		progressDialog.setMessage(message);
		progressDialog.show();
	}

	@Override
	public void needsLogin() {
		Intent intent = new Intent(Child_web_activity.this, Login_web_activity.class);
		intent.putExtra(Irekia.MAIN_LOGIN_ORIGIN_PARAM, true);
		startActivity(intent);
	}

	@Override
	public void showToast(String message) {
		Toast.makeText(this, message, Toast.LENGTH_LONG).show();
	}

	public void reload() {
		this.visible_web().reload();
		Irekia.main_Overlord.fetch_child_items(Irekia.main_Overlord.last_selected_item.get_langcode_url());
	}

	@Override
	public void update(Observable observable, Object o) {
		if (Irekia.main_Overlord == null)
			return;
		if (Irekia.is_tablet) {
			adapter.set(Irekia.main_Overlord);
			l.setVisibility(View.VISIBLE);
			update_collapsed_state(l, adapter);
			l.setSelection(Irekia.main_Overlord.last_list_visible_child);
		}
	}

	@Override
	public boolean onChildClick(ExpandableListView parent, View view, int groupPosition, int childPosition, long id) {
		if (Irekia.is_tablet) {
			item = (News_item) parent.getExpandableListAdapter().getChild(
				groupPosition, childPosition);
			flipper.setInAnimation(AnimationUtils.loadAnimation(this,
				R.anim.slide_in_left));
			flipper.setOutAnimation(AnimationUtils.loadAnimation(this,
				R.anim.slide_out_right));
			if (null != item && !item.get_langcode_url().equals("")) {
				hidden_web().clearHistory();
				hidden_web().loadUrl(item.get_langcode_url());
				this.web_view_client.set_item(item);
				setTitle("Irekia: " + item.title);
				flipper.showNext();
				// Enqueue removing content from the hidden view.
				flipper.postDelayed(this, 200);
				save_params();
				buttons.update_child(Irekia.main_Overlord, item);
			}
			return true;
		}
		return false;
	}

	@Override
	public void set_progress(int progress) {
		if (Irekia.is_tablet) {
			setCustomProgress(progress);
			View more_items = findViewById(R.id.more_items_row_layout);
			//If current result has not more results hide more_items_row
			if (progress == 10000 && more_items != null && item != null) {
				if (!item.can_fetch_more()) {
					findViewById(R.id.more_items_row_layout).findViewById(R.id.items_loading_spinner).setVisibility(View.GONE);
					findViewById(R.id.more_items_row_layout).findViewById(R.id.more_items_row_layout).setVisibility(View.GONE);
					findViewById(R.id.more_items_row_layout).findViewById(R.id.items_loading_spinner).setVisibility(View.GONE);
					((TextView) findViewById(R.id.more_items_row_layout).findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.MORE_ITEMS));
					findViewById(R.id.more_items_row_layout).setClickable(false);
				} else {
					findViewById(R.id.more_items_row_layout).findViewById(R.id.more_items_row_layout).setVisibility(View.VISIBLE);
					findViewById(R.id.more_items_row_layout).findViewById(R.id.items_loading_spinner).setVisibility(View.GONE);
					((TextView) findViewById(R.id.more_items_row_layout).findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.MORE_ITEMS));
				}
			}
		}
	}

	/**
	 * Implements fling detection on the webviews.
	 */
	private class Custom_fling_detector
		extends GestureDetector.SimpleOnGestureListener {
		public boolean onFling(MotionEvent e1, MotionEvent e2, float vX, float vY) {
			final float abs_v = Math.abs(vX);
			if (abs_v > Math.abs(vY)) {
				// Filtered horizontal movement.
				if (abs_v > swipe_threshold &&
					Math.abs(e1.getX() - e2.getX()) > swipe_distance) {
					final boolean fling_to_right = vX > 0;
					if (fling_to_right)
						switch_item(-1);
					else
						switch_item(+1);
					return true;
				}
			}
			return false;
		}
	}

	protected void update_collapsed_state(ExpandableListView list,
										  Child_news_adapter adapter) {
		for (int f = 0; f < adapter.getGroupCount(); f++) {
			Section_state section = adapter.getGroup(f);
			if (null != section) {
				if (section.collapsed)
					list.collapseGroup(f);
				else
					list.expandGroup(f);
			} else {
				list.expandGroup(f);
			}
		}
	}

/********************************** Sharekit ********************************/

	/**
	 * The user pressed the menu button, create the share menu.
	 *
	 * @return returns always true, because we always intercept the action.
	 */
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.detail_menu, menu);
		MenuItem comment = menu.findItem(R.id.new_comment);
		if (null != comment)
			comment.setVisible(item.accepts_comments);
		MenuItem vote = menu.findItem(R.id.vote);
		if (null != vote)
			vote.setVisible(item.accepts_votes);
		MenuItem argumment = menu.findItem(R.id.new_argument);
		if (null != argumment)
			argumment.setVisible(item.accepts_arguments);
		MenuItem answer = menu.findItem(R.id.answer);
		if (null != answer)
			answer.setVisible(item.accepts_answers);
		MenuItem about = menu.findItem(R.id.about);
		if (null != about)
			about.setVisible(Irekia.is_tablet);
		MenuItem settings = menu.findItem(R.id.settings);
		if (null != settings)
			settings.setVisible(Irekia.is_tablet);
		I18n.translate(menu);
		return true;
	}

	/**
	 * The user selected a menu option, what should we do?
	 *
	 * @return returns always true, because we always intercept the action.
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem menuitem) {
		switch (menuitem.getItemId()) {
			case R.id.send_by_mail: {
				if (null != item)
					Sharekit.share_item(this, menuitem.getItemId(), item);
			}
			;
			break;
			case R.id.twitter: {
				if (null != item)
					Sharekit.share_item(this, menuitem.getItemId(), item);
			}
			;
			break;
			case R.id.facebook: {
				if (null != item)
					Sharekit.share_item(this, menuitem.getItemId(), item);
			}
			;
			break;
			case R.id.vote: {
				Activity_options.doSocialAction(this, Activity_options.VOTE_ACTION, item);
			}
			;
			break;
			case R.id.new_argument: {
				Activity_options.doSocialAction(this, Activity_options.ARGUMENT_ACTION, item);
			}
			;
			break;
			case R.id.new_comment: {
				Activity_options.doSocialAction(this, Activity_options.COMMENT_ACTION, item);
			}
			;
			break;
			case R.id.answer: {
				Activity_options.doSocialAction(this, Activity_options.ANSWER_ACTION, item);
			}
			;
			break;
			case R.id.about: {
				Intent intent = new Intent(this, About_activity.class);
				startActivity(intent);
			}
			break;
			case R.id.settings: {
				Activity_options.onOptionsItemSelected(this, menuitem, Irekia.main_Overlord);
			}
			break;
		}
		return true;
	}


	private static final int SETTINGS_REQUEST_CODE = 11235;


	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if (SETTINGS_REQUEST_CODE == requestCode) {
			if (Irekia.update_shared_preferences(this, true)) {
				// Force clearing the overlords to make Tab_activity reload all.
				Irekia.main_Overlord = null;
				Intent intent = new Intent(this, Restarter_activity.class);
				startActivity(intent);
				finish();
			}
		}
	}


/****************************************************************************/

/****************************************************************************/

	/**
	 * Private class to set/update the progress visibility in the activity.
	 */
	private class Web_chrome_client extends WebChromeClient {
		public void onProgressChanged(WebView view, int progress) {
			final boolean visible = progress < 100;
			setCustomProgressBarIndeterminateVisibility(visible);
			setCustomProgressBarVisibility(visible);
			setCustomProgress(progress * 100);
		}
	}

}
