//
// OpenIrekia v2.0 Cliente Android
//
// Copyright 2009-2011 eFaber, S.L.
// Copyright 2009-2011 Ejie, S.A.
// Copyrigth 2009-2011 Dirección de Gobierno Abierto y Comunicación en Internet; 
//    Gobernu Irekirako eta Interneteko Komunikaziorako Zuzendaritza; Lehendakaritza.
//    Gobierno Vasco – Eusko Jaurlaritza 
// Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas 
// por la Comisión Europea– versiones posteriores de la EUPL (la Licencia);
// Solo podrá usarse esta obra si se respeta la Licencia. Puede obtenerse una 
// copia de la Licencia en: http://ec.europa.eu/idabc/eupl 
// Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
// el programa distribuido con arreglo a la Licencia se distribuye TAL CUAL,
// SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
// Véase la Licencia en el idioma concreto que rige los permisos y limitaciones 
// que establece la Licencia
//
//  http://open.irekia.net, openirekia@efaber.net

package net.efaber.irekia.follow;

import android.app.Activity;
import android.os.AsyncTask;
import android.util.Log;
import com.github.droidfu.http.BetterHttp;
import net.efaber.irekia.I18n;
import net.efaber.irekia.Irekia;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.params.CookiePolicy;
import org.apache.http.cookie.CookieSpecRegistry;
import org.apache.http.impl.client.BasicCookieStore;
import org.apache.http.impl.cookie.*;
import org.apache.http.message.BasicNameValuePair;

import java.io.IOException;
import java.net.ConnectException;
import java.net.URL;
import java.util.ArrayList;

import static junit.framework.Assert.assertTrue;

/**
 * Class in charge of fetching the child JSON data from the server.
 */
public class FollowTask extends AsyncTask<String, Integer, Boolean> {
	private static final String TAG = "Irekia.FollowTask";
	private final Activity activity;

	public FollowTask(Activity activity) {
		super();
		this.activity = activity;
	}

	/**
	 * Downloads and processes the retrieved JSON.
	 */
	protected Boolean doInBackground(String... urls) {
		assertTrue("This is meant to use one url", 2 == urls.length);
		try {
			activity.setProgress(2000);
			//if device has network available ask for new items
			if (Irekia.isNetworkAvailable() && Irekia.main_Overlord != null) {
				Irekia.cookieSyncManager.sync();
				if (Irekia.cookieManager.hasCookies()) {
					String c = Irekia.cookieManager.getCookie(new URL(urls[0].replace("_LNG_", I18n.get_effective_language())).getHost());
					if (c != null) {
						BasicCookieStore cookieStore = new BasicCookieStore();
						String[] cookieParts = null;
						String cookies[] = null;

						cookies = c.split(";");

						for (int i = 0; i < cookies.length; i++) {
							cookieParts = cookies[i].split("=");
							BasicClientCookie sessionCookie = new BasicClientCookie(cookieParts[0].trim(), cookieParts[1].trim());
							sessionCookie.setDomain(new URL(urls[0].replace("_LNG_", I18n.get_effective_language())).getHost());
							cookieStore.addCookie(sessionCookie);
						}
						BetterHttp.getHttpClient().setCookieStore(cookieStore);
						// not sure if I need to add all these specs, but may as well
						CookieSpecRegistry cookie_spec_registry = new CookieSpecRegistry();
						cookie_spec_registry.register(
							CookiePolicy.BEST_MATCH,
							new BestMatchSpecFactory());
						cookie_spec_registry.register(
							CookiePolicy.BROWSER_COMPATIBILITY,
							new BrowserCompatSpecFactory());
						cookie_spec_registry.register(
							CookiePolicy.NETSCAPE,
							new NetscapeDraftSpecFactory());
						cookie_spec_registry.register(
							CookiePolicy.RFC_2109,
							new RFC2109SpecFactory());
						cookie_spec_registry.register(
							CookiePolicy.RFC_2965,
							new RFC2965SpecFactory());
						BetterHttp.getHttpClient().setCookieSpecs(cookie_spec_registry);
					}
				}
				activity.setProgress(4000);
				BetterHttp.post(urls[0], new UrlEncodedFormEntity(getNameValuePairs(urls[1]))).send();
				activity.setProgress(7000);
			}
		} catch (ConnectException e) {
			e.printStackTrace();
			Log.w(TAG, "ConnectException error: " + e.getLocalizedMessage());
		} catch (IOException e) {
			e.printStackTrace();
			Log.w(TAG, "IOException error: " + e.getLocalizedMessage());
		}
		return Boolean.valueOf(false);
	}

	private ArrayList<NameValuePair> getNameValuePairs(String data) {
		ArrayList<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>();
		if (data != null && !data.equals("")) {
			String[] split = data.split("&");
			for (String pair : split) {
				String[] spare_pair = pair.split("=");
				if (spare_pair.length == 2)
					nameValuePairs.add(new BasicNameValuePair(spare_pair[0], spare_pair[1]));
			}
		}
		return nameValuePairs;
	}

	/**
	 * If new_items is valid, it is assigned to the overlord.
	 */
	protected void onPostExecute(Boolean result) {
		Irekia.cookieSyncManager.stopSync();
		if (Irekia.main_Overlord != null && Irekia.main_Overlord.last_selected_item != null)
			Irekia.main_Overlord.fetch_child_items(Irekia.main_Overlord.last_selected_item.get_langcode_url());
		activity.setProgress(10000);
	}
}
