//
// OpenIrekia v2.0 Cliente Android
//
// Copyright 2009-2011 eFaber, S.L.
// Copyright 2009-2011 Ejie, S.A.
// Copyrigth 2009-2011 Dirección de Gobierno Abierto y Comunicación en Internet; 
//    Gobernu Irekirako eta Interneteko Komunikaziorako Zuzendaritza; Lehendakaritza.
//    Gobierno Vasco – Eusko Jaurlaritza 
// Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas 
// por la Comisión Europea– versiones posteriores de la EUPL (la Licencia);
// Solo podrá usarse esta obra si se respeta la Licencia. Puede obtenerse una 
// copia de la Licencia en: http://ec.europa.eu/idabc/eupl 
// Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
// el programa distribuido con arreglo a la Licencia se distribuye TAL CUAL,
// SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
// Véase la Licencia en el idioma concreto que rige los permisos y limitaciones 
// que establece la Licencia
//
//  http://open.irekia.net, openirekia@efaber.net

package net.efaber.irekia.login;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.LinearLayout;
import net.efaber.irekia.I18n;
import net.efaber.irekia.Irekia;
import net.efaber.irekia.Irekia_default_activity;
import net.efaber.irekia.R;

public class Login_web_activity extends Irekia_default_activity {

	private WebView login_webview;
	private boolean main_mode = false;

	/**
	 * Called when the activity is first created.
	 */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.login_webview);
		getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.title);
		setTitle("Login");
		setCustomProgressBarIndeterminateVisibility(true);
		setCustomProgressBarVisibility(true);
		findViewById(R.id.title_icon_back).setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {
				if (Irekia.main_Overlord != null)
					Irekia.main_Overlord.go_home(Login_web_activity.this);
			}
		});
		Bundle extras = getIntent().getExtras();
		if (extras != null && extras.getBoolean(Irekia.MAIN_LOGIN_ORIGIN_PARAM))
			main_mode = extras.getBoolean(Irekia.MAIN_LOGIN_ORIGIN_PARAM, false);
		// Set up GUI and connect handlers.
		login_webview = (WebView) findViewById(R.id.first_webview);
		login_webview.setWebViewClient(new Web_view_client());
		login_webview.getSettings().setJavaScriptEnabled(true);
		login_webview.getSettings().setPluginsEnabled(true);
		login_webview.getSettings().setUserAgentString("Irekia/3.0");
		login_webview.addJavascriptInterface(new JSInterface(), "jsinterface");
		login_webview.setWebChromeClient(new Web_chrome_client());
		login_webview.getSettings().setDefaultZoom(WebSettings.ZoomDensity.CLOSE);
		Web_chrome_client web_chrome_client = new Web_chrome_client();
		if (Irekia.main_Overlord == null || Irekia.main_Overlord.login_webview_url == null || Irekia.main_Overlord.login_webview_url.equals(""))
			return;

		// Hide the buttons
		LinearLayout button_layout =
			(LinearLayout) findViewById(R.id.button_layout);
		if (null != button_layout)
			button_layout.setVisibility(View.GONE);
		login_webview.loadUrl(Irekia.main_Overlord.login_webview_url.replace("_LNG_", I18n.get_effective_language()));


	}

	@Override
	public void onResume() {
		super.onResume();
		Irekia.cookieSyncManager.startSync();
	}

	@Override
	protected void onStop() {
		super.onStop();
		Irekia.cookieSyncManager.stopSync();
	}

	/**
	 * Called before killing the activity. Try to save web contents.
	 */
	@Override
	protected void onSaveInstanceState(Bundle outState) {
		login_webview.saveState(outState);
	}

/****************************************************************************/

	/**
	 * Private class to set/update the progress visibility in the activity.
	 */
	private class Web_chrome_client extends WebChromeClient {
		public void onProgressChanged(WebView view, int progress) {
			final boolean visible = progress < 100;
			setCustomProgressBarIndeterminateVisibility(visible);
			setCustomProgressBarVisibility(visible);
			setCustomProgress(progress * 100);
		}


	}

	/**
	 * The actual class extending the web client to implement our custom behaviour.
	 * We just open the OS browser if available.
	 */
	private class Web_view_client extends WebViewClient {

		@Override
		public void onReceivedError(WebView view, int errorCode, String description, String failingUrl) {
			AlertDialog alertDialog = Irekia.createNoConnectionDialog(Login_web_activity.this);
			alertDialog.setOnDismissListener(new DialogInterface.OnDismissListener() {
				@Override
				public void onDismiss(DialogInterface dialogInterface) {

				}
			});
			alertDialog.show();
		}

		@Override
		public void onPageFinished(WebView view, String url) {
			if (!url.equals(Irekia.main_Overlord.login_webview_url.replace("_LNG_", I18n.get_effective_language())))
				login_webview.loadUrl("javascript:window.jsinterface.logged(document.documentElement.outerHTML);");
			super.onPageFinished(view, url);
		}

		@Override
		public void onLoadResource(WebView view, String url) {

			super.onLoadResource(view, url);
		}
	}

	/*Hack to get the loaded url source-code*/
	class JSInterface {
		public static final String FLOKI_LOGIN_AUTH_SUCCESS = "FLOKI_LOGIN_AUTH_SUCCESS";

		public void logged(String param1) {
			if (param1.contains(FLOKI_LOGIN_AUTH_SUCCESS)) {
				Login_web_activity.this.finish();
				new LoginTask(main_mode).execute();
			}
		}
	}
}


