//
// OpenIrekia v2.0 Cliente Android
//
// Copyright 2009-2011 eFaber, S.L.
// Copyright 2009-2011 Ejie, S.A.
// Copyrigth 2009-2011 Dirección de Gobierno Abierto y Comunicación en Internet; 
//    Gobernu Irekirako eta Interneteko Komunikaziorako Zuzendaritza; Lehendakaritza.
//    Gobierno Vasco – Eusko Jaurlaritza 
// Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas 
// por la Comisión Europea– versiones posteriores de la EUPL (la Licencia);
// Solo podrá usarse esta obra si se respeta la Licencia. Puede obtenerse una 
// copia de la Licencia en: http://ec.europa.eu/idabc/eupl 
// Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
// el programa distribuido con arreglo a la Licencia se distribuye TAL CUAL,
// SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
// Véase la Licencia en el idioma concreto que rige los permisos y limitaciones 
// que establece la Licencia
//
//  http://open.irekia.net, openirekia@efaber.net

package net.efaber.irekia.login;

import android.app.Activity;
import android.os.AsyncTask;
import android.util.Log;
import com.github.droidfu.http.BetterHttp;
import com.github.droidfu.http.BetterHttpResponse;
import net.efaber.irekia.Irekia;
import net.efaber.irekia.JSON;
import org.apache.http.client.params.CookiePolicy;
import org.apache.http.cookie.CookieSpecRegistry;
import org.apache.http.impl.client.BasicCookieStore;
import org.apache.http.impl.cookie.*;

import java.io.IOException;
import java.net.ConnectException;
import java.net.URL;

/**
 * Class in charge of fetching the child JSON data from the server.
 */
public class LogoutTask extends AsyncTask<String, Integer, Boolean> {
	private static final String TAG = "Irekia.LogoutTask";

	private Activity activity;


	public LogoutTask() {
		super();
	}

	public LogoutTask setActivity(Activity activity) {
		this.activity = activity;
		return this;
	}

	public void setActivityProgress(int progess) {
		if (activity != null)
			activity.setProgress(progess);
	}

	/**
	 * Downloads and processes the retrieved JSON.
	 */
	protected Boolean doInBackground(String... urls) {

		try {
			JSON json;
			setActivityProgress(2000);
			//if device has network available ask for new items
			if (Irekia.isNetworkAvailable() && Irekia.user_auth_info != null && !Irekia.user_auth_info.get_effective_Logout_url().equals("")) {
				Irekia.cookieSyncManager.startSync();
				if (Irekia.cookieManager.hasCookies()) {
					String c = Irekia.cookieManager.getCookie(new URL(Irekia.user_auth_info.get_effective_Logout_url()).getHost());
					if (c != null) {
						BasicCookieStore cookieStore = new BasicCookieStore();
						String[] cookieParts = null;
						String cookies[] = null;

						cookies = c.split(";");

						for (int i = 0; i < cookies.length; i++) {
							cookieParts = cookies[i].split("=");
							BasicClientCookie sessionCookie = new BasicClientCookie(cookieParts[0].trim(), cookieParts[1].trim());
							sessionCookie.setDomain(new URL(Irekia.user_auth_info.get_effective_Logout_url()).getHost());
							cookieStore.addCookie(sessionCookie);
						}
						BetterHttp.getHttpClient().setCookieStore(cookieStore);
						// not sure if I need to add all these specs, but may as well
						CookieSpecRegistry cookie_spec_registry = new CookieSpecRegistry();
						cookie_spec_registry.register(
							CookiePolicy.BEST_MATCH,
							new BestMatchSpecFactory());
						cookie_spec_registry.register(
							CookiePolicy.BROWSER_COMPATIBILITY,
							new BrowserCompatSpecFactory());
						cookie_spec_registry.register(
							CookiePolicy.NETSCAPE,
							new NetscapeDraftSpecFactory());
						cookie_spec_registry.register(
							CookiePolicy.RFC_2109,
							new RFC2109SpecFactory());
						cookie_spec_registry.register(
							CookiePolicy.RFC_2965,
							new RFC2965SpecFactory());
						BetterHttp.getHttpClient().setCookieSpecs(cookie_spec_registry);
					}
				}

				setActivityProgress(3000);
				BetterHttpResponse response = BetterHttp.delete(Irekia.user_auth_info.get_effective_Logout_url()).send();
				if (response.getStatusCode() == 200) {
					setActivityProgress(5000);
					response = BetterHttp.get(urls[0]).send();
					json = JSON.parse(response.getResponseBodyAsString());
					setActivityProgress(8000);
					Irekia.user_auth_info = new User_Auth_Info(json);
					if (!Irekia.user_auth_info.is_Logged()){
						Irekia.cookieManager.removeSessionCookie();
						Irekia.cookieManager.removeAllCookie();
					}
				}
			}
		} catch (ConnectException e) {
			e.printStackTrace();
			Log.w(TAG, "ConnectException error: " + e.getLocalizedMessage());
		} catch (IOException e) {
			e.printStackTrace();
			Log.w(TAG, "IOException error: " + e.getLocalizedMessage());
		}
		return Boolean.valueOf(false);
	}

	/**
	 * If new_items is valid, it is assigned to the overlord.
	 */
	protected void onPostExecute(Boolean result) {
		Irekia.cookieSyncManager.stopSync();
		if (activity != null)
			Irekia.main_Overlord.fetch_data();
		setActivityProgress(10000);
	}
}
