package net.efaber.irekia.login;

import net.efaber.irekia.I18n;
import net.efaber.irekia.JSON;

public final class User_Auth_Info {
	public String display_name;
	public String avatar;
	public String auth_type;
	public String logout_url;

	public User_Auth_Info() {
		display_name = "";
		avatar = "";
		auth_type = "";
		logout_url = "";
	}

	public User_Auth_Info(JSON json) {
		if (json != null) {
			display_name = json.get_string("display_name", "");
			avatar = json.get_string("avatar", "");
			auth_type = json.get_string("auth_type", "");
			logout_url = json.get_string("logout_url", "");
		}
		else
			clear();
	}

	public String get_effective_Logout_url() {
		return logout_url.replace("_LNG_", I18n.get_effective_language());
	}


	public boolean is_Logged() {
		return display_name != null && !display_name.equals("");
	}


	public void clear() {
		display_name = "";
		avatar = "";
		auth_type = "";
		logout_url = "";
	}
}
