package net.efaber.irekia.models.paginatedresult;

import net.efaber.irekia.I18n;
import net.efaber.irekia.Irekia;
import net.efaber.irekia.models.Content_item;
import net.efaber.irekia.models.Section_state;
import net.efaber.irekia.zerg.Overlord;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;

//PaginatedResult implementation for tags search
public final class SearchPaginatedResult implements PaginatedResult {
	private String search_url;
	private String criteria;
	private int current_page = 1;
	private List<Content_item> current_items = new ArrayList<Content_item>();
	private final Overlord overlord;
	private boolean can_fetch = true;
	private Content_item root_item;

	public SearchPaginatedResult(Overlord overlord, String criteria) {
		this.overlord = overlord;
		try {
			this.criteria = URLEncoder.encode(criteria, "UTF-8");
		} catch (UnsupportedEncodingException e) {
			this.criteria = criteria.replace(" ", "%20");
			e.printStackTrace();
		}
		this.search_url = Irekia.main_Overlord.last_selected_item.search_bar_url.replace("_PAGE_", String.valueOf(current_page)).replace("_LNG_", I18n.current_langcode).replace("_WORDS_", this.criteria);
	}

	@Override
	public List<Content_item> getCurrent_items() {
		return current_items;
	}

	@Override
	public SearchPaginatedResult setCurrent_items(List<Content_item> current_items) {
		this.current_items = current_items;
		return this;
	}

	@Override
	public PaginatedResult setCurrent_sections(ArrayList<Section_state> current_sections) {
		//Do nothing;
		return this;
	}

	@Override
	public ArrayList<Section_state> getCurrent_sections() {
		return new ArrayList<Section_state>();
	}

	@Override
	public void next() {
		this.current_page++;
	}

	@Override
	public boolean can_fetch_more() {
		return can_fetch;
	}

	@Override
	public void set_can_fetch_more(boolean can_fetch) {
		this.can_fetch = can_fetch;
	}

	@Override
	public Content_item getRoot_item() {
		return this.root_item;
	}

	@Override
	public void setRoot_item(Content_item root_item) {
		this.root_item = root_item;
	}

	@Override
	public String getSearch_url() {
		return search_url;
	}

	@Override
	public String getMore_items_url() {
		return Irekia.main_Overlord.last_selected_item.search_bar_url.replace("_PAGE_", String.valueOf(current_page)).replace("_LNG_", I18n.current_langcode).replace("_WORDS_", criteria);
	}
}
