package net.efaber.irekia.models.paginatedresult;

import net.efaber.irekia.Irekia;
import net.efaber.irekia.models.Content_item;
import net.efaber.irekia.models.Section_state;
import net.efaber.irekia.zerg.Overlord;

import java.util.ArrayList;
import java.util.List;

public final class SinglePaginatedResult implements PaginatedResult {
	private String search_url;
	private List<Content_item> current_items = new ArrayList<Content_item>();
	private ArrayList<Section_state> current_sections = new ArrayList<Section_state>();
	private final Overlord overlord;
	private int mode;
	private boolean can_fetch = true;
	private Content_item root_item;

	public SinglePaginatedResult(Overlord overlord, String url, int mode) {
		this.overlord = overlord;
		this.search_url = url;
		this.mode = mode;
	}

	@Override
	public List<Content_item> getCurrent_items() {
		return current_items;
	}

	@Override
	public SinglePaginatedResult setCurrent_items(List<Content_item> current_items) {
		this.current_items = current_items;
		return this;
	}

	@Override
	public PaginatedResult setCurrent_sections(ArrayList<Section_state> current_sections) {
		this.current_sections = current_sections;
		return this;
	}

	@Override
	public ArrayList<Section_state> getCurrent_sections() {
		return this.current_sections;
	}

	@Override
	public void next() {
	}

	@Override
	public boolean can_fetch_more() {
		return (this.mode == Irekia.MODE_TAGS || this.mode == Irekia.MODE_CHILD);
	}

	@Override
	public void set_can_fetch_more(boolean can_fetch) {
		this.can_fetch = can_fetch;
	}

	@Override
	public String getSearch_url() {
		return search_url;
	}

	@Override
	public String getMore_items_url() {
		if (this.mode != Irekia.MODE_TAGS && this.mode != Irekia.MODE_CHILD)
			return "";
		if (Irekia.main_Overlord == null || Irekia.main_Overlord.child_items == null || Irekia.main_Overlord.child_items.size() == 0)
			return "";
		int item_id = Irekia.main_Overlord.child_items.get(Irekia.main_Overlord.child_items.size() - 1).id;
		if (search_url.indexOf("?") == -1)
			return search_url + "?o=" + item_id;
		else if (search_url.indexOf("?o=") != -1 && search_url.indexOf("&") == -1)
			return updateQueryString(search_url, "o", String.valueOf(item_id)).replace("&", "");
		else
			return updateQueryString(search_url, "o", String.valueOf(item_id));
	}


	public static String updateQueryString(String queryString, String name, String value) {
		if (queryString != null) {
			queryString = queryString.replaceAll(name + "=.*?($|&)", "").replaceFirst("&$", "");
		}
		return ("").equals(queryString) ? (name + "=" + value) : (queryString + "&" + name + "=" + value);
	}

	public void setCan_fetch(boolean can_fetch) {
		this.can_fetch = can_fetch;
	}

	@Override
	public Content_item getRoot_item() {
		return root_item;
	}

	@Override
	public void setRoot_item(Content_item root_item) {
		this.root_item = root_item;
	}
}
