package net.efaber.irekia.models.paginatedresult;

import net.efaber.irekia.models.Content_item;
import net.efaber.irekia.models.Section_state;

import java.util.ArrayList;
import java.util.List;

//PaginatedResult implementation for tags urls
public final class TagsPaginatedResult implements PaginatedResult {
	private String search_url;
	private int current_page = 1;
	private List<Content_item> current_items = new ArrayList<Content_item>();
	private boolean can_fetch = true;
	private Content_item root_item;


	public TagsPaginatedResult(String url) {
		this.search_url = url;
	}

	@Override
	public List<Content_item> getCurrent_items() {
		return current_items;
	}


	@Override
	public TagsPaginatedResult setCurrent_items(List<Content_item> current_items) {
		this.current_items = current_items;
		return this;
	}

	@Override
	public PaginatedResult setCurrent_sections(ArrayList<Section_state> current_sections) {
		//Do nothing;
		return this;
	}

	@Override
	public ArrayList<Section_state> getCurrent_sections() {
		return new ArrayList<Section_state>();
	}

	@Override
	public void next() {
		this.current_page++;
	}

	@Override
	public boolean can_fetch_more() {
		return can_fetch;
	}

	@Override
	public void set_can_fetch_more(boolean can_fetch) {
		this.can_fetch = can_fetch;
	}

	@Override
	public String getSearch_url() {
		return search_url + "&page=" + current_page;
	}

	@Override
	public String getMore_items_url() {
		return search_url + "&page=" + current_page;
	}

	@Override
	public Content_item getRoot_item() {
		return root_item;
	}

	@Override
	public void setRoot_item(Content_item root_item) {
		this.root_item = root_item;
	}
}
