package net.efaber.irekia.social.create.step;

import android.app.AlertDialog;
import net.efaber.irekia.I18n;
import net.efaber.irekia.JSON;
import net.efaber.irekia.social.create.StepController;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public abstract class Step {
	final StepController stepController;
	final StepType stepType;
	final JSON json;
	final Map<String, Object> current_step_vars = new HashMap<String, Object>();
	String step_var;
	int step_line_int;
	String step_line_string;
	int step_title_int;
	String step_title_string;
	String step_post_url;
	List<String> step_post_vars = new ArrayList<String>();
	int step_next_button_int;
	String step_next_button_string;

	protected Step(JSON json, StepController stepController, StepType stepType) {
		this.json = json;
		this.stepController = stepController;
		this.stepType = stepType;
		step_var = json.get_string("step_var", "");
		step_line_int = json.get_int("step_line", -1);
		step_line_string = json.get_string("step_line", "");
		step_title_int = json.get_int("step_title", -1);
		step_title_string = json.get_string("step_title", "");
		step_post_url = json.get_string("step_post_url", "").replace("_LNG_", I18n.get_effective_language());
		step_post_vars = json.get_array("step_post_vars", new ArrayList<String>(), String.class);
		step_next_button_int = json.get_int("step_next_button", -1);
		step_next_button_string = json.get_string("step_next_button", "");
	}

	public abstract AlertDialog showDialog(boolean load);


	protected String getTranslatedStringLine() {
		return (step_line_int != -1) ? I18n.p(step_line_int) : step_line_string;
	}

	protected String getTranslatedStringTitle() {
		return (step_title_int != -1) ? I18n.p(step_title_int) : step_title_string;
	}

	protected String getTranslatedNextButton() {
		return (step_next_button_int != -1) ? I18n.p(step_next_button_int) : step_next_button_string;
	}

	public String getStep_post_url() {
		return step_post_url;
	}

	public Map<String, Object> getCurrent_step_vars() {
		return current_step_vars;
	}

	public List<String> getStep_post_vars() {
		return step_post_vars;
	}
}
