package net.efaber.irekia.social.create.step;

import com.google.common.base.Objects;
import net.efaber.irekia.JSON;
import net.efaber.irekia.social.create.StepController;

import java.lang.reflect.InvocationTargetException;

public enum StepType {
	TEXT(StepType.TEXT_TYPE_AS_STRING, TextStep.class),
	CHOICE(StepType.CHOICE_TYPE_AS_STRING, ChoiceStep.class),
	SEARCH(StepType.SEARCH_TYPE_AS_STRING, SearchStep.class);

	static final String TEXT_TYPE_AS_STRING = "text";
	static final String CHOICE_TYPE_AS_STRING = "choice";
	static final String SEARCH_TYPE_AS_STRING = "search";

	String stepType = "";
	Class stepClass;

	StepType(String stepType, Class stepClass) {
		this.stepType = stepType;
		this.stepClass = stepClass;
	}

	public String toValue() {
		return stepType;
	}

	public static StepType fromValue(String stepTypeAsString) {
		for (StepType stepType : StepType.values()) {
			if (Objects.equal(stepType.stepType, stepTypeAsString))
				return stepType;
		}
		throw new IllegalArgumentException("StepType Type " + stepTypeAsString + " not supported");
	}

	public Step getStep(JSON json, StepController stepController) throws NoSuchMethodException {
		try {
			return (Step) stepClass.getConstructor(JSON.class, StepController.class)
				.newInstance(json, stepController);
		} catch (Exception e) {
			throw new IllegalArgumentException("StepType Type " + stepType + " not supported");
		}
	}

}