//
// OpenIrekia v2.0 Cliente Android
//
// Copyright 2009-2011 eFaber, S.L.
// Copyright 2009-2011 Ejie, S.A.
// Copyrigth 2009-2011 Dirección de Gobierno Abierto y Comunicación en Internet; 
//    Gobernu Irekirako eta Interneteko Komunikaziorako Zuzendaritza; Lehendakaritza.
//    Gobierno Vasco – Eusko Jaurlaritza 
// Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas 
// por la Comisión Europea– versiones posteriores de la EUPL (la Licencia);
// Solo podrá usarse esta obra si se respeta la Licencia. Puede obtenerse una 
// copia de la Licencia en: http://ec.europa.eu/idabc/eupl 
// Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
// el programa distribuido con arreglo a la Licencia se distribuye TAL CUAL,
// SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
// Véase la Licencia en el idioma concreto que rige los permisos y limitaciones 
// que establece la Licencia
//
//  http://open.irekia.net, openirekia@efaber.net

package net.efaber.irekia.volatilecontroller;

import android.os.Bundle;
import android.view.*;
import android.view.ContextMenu.ContextMenuInfo;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import net.efaber.irekia.*;
import net.efaber.irekia.activities.util.ExpandableHeightGridView;
import net.efaber.irekia.gallery.Gallery_data;
import net.efaber.irekia.models.Activity_progress;
import net.efaber.irekia.models.Gallery_item;

import java.text.ParseException;
import java.util.Observable;
import java.util.Observer;

/**
 * Shows a list of items.
 */
public class Volatile_gallery_activity extends Irekia_default_activity
	implements Observer, OnItemClickListener, Activity_progress {
	private Volatile_gallery_adapter adapter;
	private ExpandableHeightGridView g;

	private Post_rotation r;

	/// Stores the last known progress.
	private int last_progress = 10000;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.photo_gallery);
		getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.title);
		setCustomProgressBarIndeterminateVisibility(true);
		setCustomProgressBarVisibility(true);
		findViewById(R.id.title_icon_back).setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {
				if (Irekia.main_Overlord != null)
					Irekia.main_Overlord.go_home(Volatile_gallery_activity.this);
			}
		});
		// Recover rotation persistant variables.
		r = (Post_rotation) getLastNonConfigurationInstance();
		if (null == r)
			r = new Post_rotation();
		findViewById(R.id.more_items_row_layout).setVisibility(View.GONE);
		Bundle extras = getIntent().getExtras();
		String title = "Irekia";
		String url = "";
		if (null != extras) {
			if (extras.getString(Irekia.TITLE_PARAM) != null)
				title = extras.getString(Irekia.TITLE_PARAM);
			if (extras.getString(Irekia.SEARCH_URL_PARAM) != null)
				url = extras.getString(Irekia.SEARCH_URL_PARAM);
		}
		setTitle(title);

		Irekia.main_Overlord.fetch_volatile_items(url, Irekia.MODE_PHOTO);

		Gallery_data gallery_data;
		if (null == Irekia.main_Overlord.last_selected_item)
			return;
		try {
			if (Irekia.main_Overlord.last_selected_item.data != null && !Irekia.is_tablet)
				gallery_data = new Gallery_data(Irekia.main_Overlord.last_selected_item.data);
			else
				gallery_data = new Gallery_data(Irekia.main_Overlord.generic_gallery_data);
		} catch (ParseException e) {
			e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
			return;
		}

		Irekia.main_Overlord.set_progress_reporter(this);
		adapter = new Volatile_gallery_adapter(this, gallery_data);
		adapter.set_items(Irekia.main_Overlord.volatile_items);

		g = (ExpandableHeightGridView) findViewById(R.id.gallery_grid);
		g.setId(13);
		g.setAdapter(adapter);

		// Configure some looks for the grid.
		g.setNumColumns(gallery_data.cells_per_row);
		g.setGravity(Gravity.CENTER);
		g.setVerticalSpacing((int) (gallery_data.padding * 2 * Irekia.density));
		g.setHorizontalSpacing((int) (gallery_data.padding * 2 * Irekia.density));

		g.setBackgroundColor(android.R.color.black);
		g.setDrawingCacheBackgroundColor(android.R.color.black);
		g.setCacheColorHint(android.R.color.black);

		g.setOnItemClickListener(this);
		g.setExpanded(true);
		registerForContextMenu(g);
		Irekia.set_empty_view(g, this);
	}

	public void onResume() {
		super.onResume();
		if (null == Irekia.main_Overlord)
			return;
		Irekia.main_Overlord.set_progress_reporter(this);
		Irekia.main_Overlord.volatile_items.addObserver(this);
	}

	@Override
	protected void onRestart() {
		super.onRestart();
		if (Irekia.is_tablet && Irekia.close_prev) {
			Irekia.close_prev = false;
			this.finish();
			return;
		}
	}

	@Override
	public void update(Observable observable, Object data) {
		int scrollY = findViewById(R.id.parent_scroll).getScrollY();
		int scrollX = findViewById(R.id.parent_scroll).getScrollX();
		r.last_fetch = Irekia.main_Overlord.last_update;
		adapter.set_items(Irekia.main_Overlord.volatile_items);
		adapter.notifyDataSetChanged();
		findViewById(R.id.parent_scroll).scrollTo(scrollX, scrollY);
	}

	/**
	 * Pass some parameters to our future self after rotation.
	 * We want to preserve some data like the r.last_fetch timestamp after a
	 * rotation, so we communicate it here.
	 */
	@Override
	public Object onRetainNonConfigurationInstance() {
		return r;
	}


	/**
	 * Handles the user clicking or selecting an item with.
	 * The item's url will be loaded in a new web activity.
	 */
	@Override
	public void onItemClick(AdapterView<?> parent, View view, int pos, long id) {
		Gallery_item item = (Gallery_item) Irekia.main_Overlord.volatile_items.get(pos);
		item.start_volatile_activity(this, Irekia.main_Overlord);
	}

	/**
	 * Interface to let the Overlord notify us of download progresses.
	 */
	public void set_progress(int progress) {
		last_progress = progress;
		setCustomProgress(progress);
	}

	@Override
	public void onPause() {
		super.onPause();
		if (null == Irekia.main_Overlord)
			return;
		Irekia.main_Overlord.volatile_items.deleteObserver(this);
	}

/*********************** Common activity options menu ***********************/

	/**
	 * The user pressed the menu button, create the menu.
	 */
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		return Activity_options.onCreateVolatileOptionsMenu(this, menu, false);
	}

	/**
	 * The user selected a menu option, what should we do?
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		return Activity_options.onOptionsItemSelected(this, item, Irekia.main_Overlord);
	}


	/**
	 * ******************************* Sharekit *******************************
	 */

	@Override
	public void onCreateContextMenu(ContextMenu menu, View v,
									ContextMenuInfo menuInfo) {
		super.onCreateContextMenu(menu, v, menuInfo);
		Sharekit.onCreateContextMenu(this, menu, v, menuInfo);
	}

	@Override
	public boolean onContextItemSelected(MenuItem item) {
		return Sharekit.onVolatileContextItemSelected(this, item, Irekia.main_Overlord);
	}

/****************************************************************************/

	/**
	 * Custom private class to preserve data between rotations.
	 */
	private class Post_rotation {
		public long last_fetch;
		public boolean did_fetch;
	}

}
