package net.efaber.irekia.volatilecontroller;

import android.content.Intent;
import android.os.Bundle;
import android.view.*;
import android.widget.ExpandableListView;
import android.widget.TextView;
import android.widget.Toast;
import net.efaber.irekia.*;
import net.efaber.irekia.models.Activity_progress;
import net.efaber.irekia.models.News_item;
import net.efaber.irekia.models.Section_state;
import net.efaber.irekia.news.News_data;
import net.efaber.irekia.news.News_row;

import java.text.ParseException;
import java.util.Observable;
import java.util.Observer;

public class Volatile_list_activity extends Irekia_expandable_list_activity
	implements Observer, ExpandableListView.OnChildClickListener, Activity_progress {

	private Post_rotation r;
	private ExpandableListView l;
	/// Watchdog to control and know if is needed to restore previous items (back navigations)
	private boolean restore_previous_items_needed = false;
	private boolean is_sharing = false;
	private boolean is_navigating_to_child = false;
	private View empty = null;
	private int lastMode;

	/// Stores the last known progress.
	private int last_progress = 10000;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		restore_previous_items_needed = false;
		setContentView(R.layout.expandable_list);
		getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.title);
		setTitle(R.string.app_name);
		setCustomProgressBarIndeterminateVisibility(true);
		setCustomProgressBarVisibility(true);
		findViewById(R.id.title_icon_back).setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {
				if (Irekia.main_Overlord != null)
					Irekia.main_Overlord.go_home(Volatile_list_activity.this);
			}
		});
		// Recover rotation persistant variables.
		r = (Post_rotation) getLastNonConfigurationInstance();
		if (null == r)
			r = new Post_rotation();

		int mode = -1;
		Bundle extras = getIntent().getExtras();
		String title = "Irekia";
		String url = "";
		if (null != extras) {
			if (extras.getString(Irekia.TITLE_PARAM) != null)
				title = extras.getString(Irekia.TITLE_PARAM);
			if (extras.getInt(Irekia.MODE_PARAM, -1) != -1)
				mode = extras.getInt(Irekia.MODE_PARAM);
			if (extras.getString(Irekia.SEARCH_URL_PARAM) != null)
				url = extras.getString(Irekia.SEARCH_URL_PARAM);
		}
		this.lastMode = mode;
		if (Irekia.main_Overlord != null && !url.equals("") && mode == Irekia.MODE_TAGS)
			Irekia.main_Overlord.fetch_tags(url);
		else if (this.lastMode != Irekia.MODE_SEARCH)
			Irekia.main_Overlord.fetch_volatile_items(url, mode);
		setTitle(title);

		if (null == Irekia.main_Overlord)
			return;

		Irekia.main_Overlord.set_progress_reporter(this);

		News_data news_data;
		try {
			if (Irekia.main_Overlord.last_selected_item.data != null)
				news_data = new News_data(Irekia.main_Overlord.last_selected_item.data);
			else
				news_data = new News_data(Irekia.main_Overlord.generic_news_data);
		} catch (ParseException e) {
			e.printStackTrace();
			return;
		}
		l = getExpandableListView();
		l.setId(android.R.id.list);
		l.setChildDivider(getResources().getDrawable(R.color.r_light_gray));
		l.setDivider(getResources().getDrawable(R.color.r_light_gray));
		l.setDividerHeight((int) (Irekia.density + 0.5f));
		l.setGroupIndicator(getResources().getDrawable(R.drawable.empty_expandable));
		Volatile_news_adapter adapter = new Volatile_news_adapter(this, news_data);
		//Create more_items_row to allow user to ask for new items

		final View more_items_row = getLayoutInflater().inflate(R.layout.load_more_items, null);
		((TextView) more_items_row.findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.MORE_ITEMS));
		more_items_row.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View view) {
				//Change more_items_row state to show loading spinner
				more_items_row.findViewById(R.id.items_loading_spinner).setVisibility(View.VISIBLE);
				((TextView) more_items_row.findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.DOWNLOADING_DATA));
				//Avoid asking for more items until last search is ended
				more_items_row.setClickable(false);
				//Fetch more volatile items
				Irekia.main_Overlord.fetch_more_volatile(lastMode);
			}
		});

		adapter.set(Irekia.main_Overlord);
		//if Overlord current result can fetch more items Add more_items_row
		if (Irekia.main_Overlord != null
			&& Irekia.main_Overlord.current_volatile_paginated_result != null
			&& Irekia.main_Overlord.current_volatile_paginated_result.can_fetch_more()
			) {
			l.addFooterView(more_items_row);
			more_items_row.setVisibility(View.VISIBLE);
		} else
			//Update more_items_row visibility
			more_items_row.setVisibility(View.GONE);
		setListAdapter(adapter);
		l.setOnGroupCollapseListener(adapter);
		l.setOnGroupExpandListener(adapter);
		// Configure some looks for the listview.
		l.setBackgroundColor(news_data.back_normal_color);
		l.setDrawingCacheBackgroundColor(news_data.back_normal_color);
		l.setCacheColorHint(news_data.back_normal_color);

		l.setOnChildClickListener(this);
		registerForContextMenu(l);
		l.setVisibility(View.GONE);
		empty = getLayoutInflater().inflate(R.layout.empty, (ViewGroup) getExpandableListView().getParent(), false);
		TextView text = (TextView) empty.findViewById(R.id.connecting_text);
		if (null != text)
			text.setText(I18n.e(I18n.Embedded_string.CONNECTING_TO_SERVER));
		((ViewGroup) getExpandableListView().getParent()).addView(empty);
	}

	@Override
	protected void onRestart() {
		super.onRestart();
		l.setVisibility(View.VISIBLE);
		if (empty != null)
			empty.setVisibility(View.GONE);
		if (!is_sharing && is_navigating_to_child)
			restore_previous_items_needed = true;
		is_sharing = false;
		setCustomProgressBarVisibility(false);
	}

	@Override
	public void onResume() {
		super.onResume();
		if (null == Irekia.main_Overlord)
			return;
		Irekia.main_Overlord.set_progress_reporter(this);
		is_navigating_to_child = false;
		Irekia.main_Overlord.volatile_items.addObserver(this);
		if (restore_previous_items_needed) {
			Irekia.main_Overlord.restore_previous_volatiles();
			if (Irekia.is_tablet && Irekia.close_prev) {
				Irekia.close_prev = false;
				this.finish();
				return;
			}
		}
		update_collapsed_state(getExpandableListView(),
			(Volatile_news_adapter) getExpandableListAdapter());
	}

	@Override
	public void onPause() {
		super.onPause();
		if (!is_navigating_to_child)
			restore_previous_items_needed = false;
		if (null == Irekia.main_Overlord)
			return;
		if (Irekia.is_tablet)
			Irekia.main_Overlord.last_list_visible_child = getExpandableListView().getFirstVisiblePosition();
		Irekia.main_Overlord.volatile_items.deleteObserver(this);
	}

	@Override
	public void onBackPressed() {
		Irekia.main_Overlord.cancel_volatile_fetching();
		super.onBackPressed();
	}

	/**
	 * Pass some parameters to our future self after rotation.
	 * We want to preserve some data like the r.last_fetch timestamp after a
	 * rotation, so we communicate it here.
	 */
	@Override
	public Object onRetainNonConfigurationInstance() {
		return r;
	}

	/**
	 * Handles the user clicking or selecting an item with.
	 * The item's url will be loaded in a new web activity.
	 */
	@Override
	public boolean onChildClick(ExpandableListView parent, View view,
								int groupPosition, int childPosition, long id) {
		News_item item = (News_item) parent.getExpandableListAdapter().getChild(
			groupPosition, childPosition);
		is_navigating_to_child = true;
		Irekia.main_Overlord.save_previous_volatiles();
		if (null != item) {
			item.start_volatile_activity(this, Irekia.main_Overlord, lastMode);
			return true;
		} else {
			Toast.makeText(this, "Internal error processing item id!",
				Toast.LENGTH_SHORT).show();
			return false;
		}
	}

	/**
	 * Modifies the collapsed state of all groups in a listview.
	 * The collapsed state comes out of the attribute for the Section_state objects.
	 */
	protected void update_collapsed_state(ExpandableListView list,
										  Volatile_news_adapter adapter) {
		for (int f = 0; f < adapter.getGroupCount(); f++) {
			Section_state section = adapter.getGroup(f);
			if (null != section) {
				if (section.collapsed)
					list.collapseGroup(f);
				else
					list.expandGroup(f);
			} else {
				list.expandGroup(f);
			}
		}
	}

	/**
	 * Interface to let the Overlord notify us of download progresses.
	 */
	public void set_progress(int progress) {
		last_progress = progress;
		setCustomProgress(progress);
		View more_items = findViewById(R.id.more_items_row_layout);
		//If current result has not more results hide more_items_row
		if (progress == 10000 && more_items != null && Irekia.main_Overlord != null
			&& !Irekia.main_Overlord.current_volatile_paginated_result.can_fetch_more()) {
			findViewById(R.id.more_items_row_layout).findViewById(R.id.more_items_row_layout).setVisibility(View.GONE);
			findViewById(R.id.more_items_row_layout).findViewById(R.id.items_loading_spinner).setVisibility(View.GONE);
			((TextView) findViewById(R.id.more_items_row_layout).findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.MORE_ITEMS));
			findViewById(R.id.more_items_row_layout).setClickable(false);
		}
		if (progress == 10000 && Irekia.main_Overlord.volatile_items.size() == 0) {
			TextView text = (TextView) empty.findViewById(R.id.connecting_text);
			text.setText(Irekia.main_Overlord.last_selected_item != null ? Irekia.main_Overlord.last_selected_item.get_empty_message() : I18n.e(I18n.Embedded_string.IREKIA_NO_RESULTS));
			empty.setVisibility(View.VISIBLE);
		}
	}

/*********************** Common activity options menu ***********************/

	/**
	 * The user pressed the menu button, create the menu.
	 */
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		return Activity_options.onCreateVolatileOptionsMenu(this, menu, this.lastMode == Irekia.MODE_SEARCH);
	}

	/**
	 * The user selected a menu option, what should we do?
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		return Activity_options.onOptionsItemSelected(this, item, Irekia.main_Overlord);
	}

	/**
	 * Method that gets called when the settings activity has finished.
	 * Now we can pick up the list of changes and see if we need to refresh
	 * ourselves.
	 */
	@Override
	public void onActivityResult(int requestCode, int resultCode, Intent data) {
		super.onActivityResult(requestCode, resultCode, data);
		Activity_options.onActivityResult(this, requestCode);
	}

	/**
	 * ******************************* Sharekit *******************************
	 */

	@Override
	public void onCreateContextMenu(ContextMenu menu, View v,
									ContextMenu.ContextMenuInfo menuInfo) {
		ExpandableListView.ExpandableListContextMenuInfo info = (ExpandableListView.ExpandableListContextMenuInfo) menuInfo;
		News_item content_item = ((News_row) info.targetView).get_content_item();
		if (content_item != null && (content_item.class_type.equals("Login_cell")) || content_item.class_type.equals("Follow_cell") || content_item.share_url == null || content_item.share_url.equals(""))
			return;
		super.onCreateContextMenu(menu, v, menuInfo);
		Sharekit.onCreateContextMenu(this, menu, v, menuInfo);
	}

	@Override
	public boolean onContextItemSelected(MenuItem item) {
		is_sharing = true;
		return Sharekit.onVolatileContextItemSelected(this, item, Irekia.main_Overlord);
	}

	/**
	 * Gets notifications about updates to the list of Overlord items.
	 * The observable will actually be the overlord. The data is always null (?).
	 */
	@Override
	public void update(Observable observable, Object data) {

		//If current result has more results change state
		if (Irekia.main_Overlord != null
			&& Irekia.main_Overlord.current_volatile_paginated_result != null
			&& Irekia.main_Overlord.current_volatile_paginated_result.can_fetch_more()) {
			//Change_more_items_row state
			findViewById(R.id.more_items_row_layout).findViewById(R.id.items_loading_spinner).setVisibility(View.GONE);
			((TextView) findViewById(R.id.more_items_row_layout).findViewById(R.id.more_items_text)).setText(I18n.e(I18n.Embedded_string.MORE_ITEMS));
			findViewById(R.id.more_items_row_layout).setClickable(true);
		}
		Volatile_news_adapter adapter = (Volatile_news_adapter) getExpandableListAdapter();
		adapter.set(Irekia.main_Overlord);
		l.setVisibility(View.VISIBLE);
		if (empty != null)
			empty.setVisibility(View.GONE);
		update_collapsed_state(getExpandableListView(), adapter);
	}


/****************************************************************************/

	/**
	 * Custom private class to preserve data between rotations.
	 */
	private class Post_rotation {
		public long last_fetch;
		public boolean did_fetch;
	}

}
