//
// OpenIrekia v2.0 Cliente Android
//
// Copyright 2009-2011 eFaber, S.L.
// Copyright 2009-2011 Ejie, S.A.
// Copyrigth 2009-2011 Dirección de Gobierno Abierto y Comunicación en Internet; 
//    Gobernu Irekirako eta Interneteko Komunikaziorako Zuzendaritza; Lehendakaritza.
//    Gobierno Vasco – Eusko Jaurlaritza 
// Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas 
// por la Comisión Europea– versiones posteriores de la EUPL (la Licencia);
// Solo podrá usarse esta obra si se respeta la Licencia. Puede obtenerse una 
// copia de la Licencia en: http://ec.europa.eu/idabc/eupl 
// Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
// el programa distribuido con arreglo a la Licencia se distribuye TAL CUAL,
// SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
// Véase la Licencia en el idioma concreto que rige los permisos y limitaciones 
// que establece la Licencia
//
//  http://open.irekia.net, openirekia@efaber.net

package net.efaber.irekia.zerg;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.os.AsyncTask;
import net.efaber.irekia.I18n;
import net.efaber.irekia.Irekia;
import net.efaber.irekia.JSON;
import net.efaber.irekia.activities.Main_activity;
import net.efaber.irekia.childcontroller.Child_gallery_activity;
import net.efaber.irekia.childcontroller.Child_list_activity;
import net.efaber.irekia.gallery.Gallery_data;
import net.efaber.irekia.models.*;
import net.efaber.irekia.models.paginatedresult.PaginatedResult;
import net.efaber.irekia.models.paginatedresult.SearchPaginatedResult;
import net.efaber.irekia.models.paginatedresult.SinglePaginatedResult;
import net.efaber.irekia.models.paginatedresult.TagsPaginatedResult;
import net.efaber.irekia.news.News_data;
import smartlistadapter.SmartList;

import java.lang.ref.WeakReference;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.List;
import java.util.Stack;

import static junit.framework.Assert.assertTrue;

public class Overlord
	implements Runnable {
	/// Private pointer to the activity showing progress.
	private WeakReference<Activity_progress> progress_reporter;

	/// Unique identifier of the overlord. Used to access the database and tabs.
	public int id;

	/// The feed's URL. Note that this is not used, but rather langcode_url.
	String url;

	/// And this is url + the current language code if necessary.
	String langcode_url;

	/// True if we allow manual reloads for the Overlord.
	public boolean allow_manual_reload;
	/// Time to live of the fetched data in seconds. If zero or less, there
/// will be made no network requests for updates.
	int ttl;
	/// Witness to detect if we are already in the global refresh queue.
	private boolean queued_for_refreshes;

	/// Time of the last network update in miliseconds. Stored to disk.
	public long last_update;
	/// If true, activating the controller always fetches from the network,
/// regardless of ttl and last_update.
	boolean download_if_virgin;

	/// Stores the tag to search for items in the parsed JSON.
	String race_tag;
	/// Stores the class used to construct new items.
	@SuppressWarnings("rawtypes")
	public Class race_class;
	public Class<? extends Content_item> race_item_class;

	/// Stores the items of the view. Always works, albeit empty.
	public SmartList<Content_item> items;
	/// Stores the sections of the view. Always works, albeit empty.
	public ArrayList<Section_state> sections;
	/// Maximum number of items to show in the view. Excedent is purged.
	int cache_size;
	/// Values automatically set when you modify the list of items.
	int max_item_id, min_item_id;

	/// Internal witness for remote network activity start.
	boolean already_doing_network_fetches;

	/// Tells us if the Overlord already loaded cached information.
	boolean disk_loaded;

	/// Stores the child items. Items that are not associated to an Overlord, are produced by tag search or text search
	public SmartList<Content_item> child_items = new SmartList<Content_item>();
	/// Simple stack to store child items as PaginatedResult between activity navigations
	public Stack<PaginatedResult> previous_child_items = new Stack<PaginatedResult>();
	/// Stores the child sections
	public ArrayList<Section_state> child_sections = new ArrayList<Section_state>();
	//Current paginated result to deal with child items, paginate, search...
	public PaginatedResult current_paginated_result;
	/// Stores the child items. Items that are not associated to an Overlord, are produced by tag search or text search
	public SmartList<Content_item> volatile_items = new SmartList<Content_item>();
	/// Simple stack to store child items as PaginatedResult between activity navigations
	public Stack<PaginatedResult> previous_volatile_items = new Stack<PaginatedResult>();
	/// Stores the child sections
	public ArrayList<Section_state> volatile_sections = new ArrayList<Section_state>();
	//Current paginated result to deal with child items, paginate, search...
	public PaginatedResult current_volatile_paginated_result;

	/// Public URL for user consumption if available.
	public ArrayList<String> tags_regex;
	/// Public URL for user consumption if available.
	public ArrayList<String> videos_regex;

	/// Ventral sacs hold the data JSON used to spawn new view controllers.
	JSON ventral_sacs;
	/// The ventral class holds the name of the class used to spawn views.
	public String ventral_class;

	/**
	 * The following should not be part of the overlord but of the TabSpec.
	 */

/// Long title of the tab. This should not be a part of the overlod.
	public int long_title_id;
	/// Short title of the tab. This should not be a part of the overlod.
	public int short_title_id;
	public String title;
	/// Bitmap containing the base64 of the tab image. Null if there is none.
	public Bitmap tab_image;

	/// Processed json data contained in the ventral_sacs. Null if there is none.
	public Object parsed_data;

	/// Remembers if this is downloading something or not.
	private boolean is_fetching_data;
	/// And this is url + the current language code if necessary.
	public String search_bar_url;
	/// Watchdog to know if last fetched data has older items
	public boolean has_older = true;

	public Content_item last_selected_item;

	public JSON generic_gallery_data;
	public JSON generic_news_data;
	public String login_webview_url;
	public String auth_info_url;
	private ChildDownloaderTask currentChildDownloaderTask;
	private VolatileDownloaderTask currentVolatileDownloaderTask;
	private RootDownloaderTask currentRootDownloaderTask;
	//	Public URL for user consumption if available.
	public ArrayList<String> intralinks_regex = new ArrayList<String>();
	public static int last_list_visible_child = 0;

	public Overlord(JSON json, boolean isRoot)
		throws ParseException {
		JSON data;
		if (isRoot)
			data = json;
		else
			data = json.get_map("data", null);
		if (null == data)
			throw new ParseException("Overlord data can't be null", 0);

		String class_type = json.get_string("class_type", "News_view_controller");
		if (class_type.length() < 1)
			throw new ParseException("Can't create overlord without class type. " +
				json, 1);

		race_class = Child_list_activity.class;
		race_item_class = News_item.class;
		if (class_type.equals("Gallery_view_controller")) {
			race_class = Child_gallery_activity.class;
			race_item_class = Gallery_item.class;
			race_tag = "thumbs";
		} else if (class_type.equals("News_view_controller")) {
			race_tag = "items";
		}

		id = json.get_int("unique_id", 0) != 0 ? json.get_int("unique_id", 0) : data.get_int("unique_id", 0);
		if (id < 1)
			throw new ParseException("Can't create overlord with unique_id < 1" +
				json, 2);

		url = data.get_url("main_url", null) == null ? ((String) json.data.get("url")) : data.get_url("main_url", null);
		if (null == url)
			throw new ParseException("Can't create overlord with null main_url", 3);
		langcode_url = url.replace("_LNG_", I18n.current_langcode);
		allow_manual_reload = data.get_bool("allow_manual_reload", false);
		ttl = data.get_int("ttl", 300);
		if (ttl < 1)
			throw new ParseException("ttl has to be a positive value", 4);
		download_if_virgin = data.get_bool("download_if_virgin", false);
		cache_size = data.get_int("cache_size", 50);
		if (cache_size < 1)
			throw new ParseException("cache_size has to be a positive value", 5);
		long_title_id = json.get_int("long_title", -1);
		short_title_id = json.get_int("short_title", -1);
		title = json.get_string("title", "");
		tab_image = json.get_image("tab_image", null);

		// TODO: Make this generic, possibly from class type.
		if (Child_gallery_activity.class == race_class)
			parsed_data = new Gallery_data(data);
		else
			parsed_data = new News_data(data);

		search_bar_url = data.get_string("search_bar", "");
		ventral_sacs = data;
		ventral_class = class_type;
		items = new SmartList<Content_item>();
		sections = new ArrayList<Section_state>();

	}

	/**
	 * Starts a network update in a separate thread.
	 * If you want to be notified of updates, just add yourself as observer to the
	 * smartlist.
	 */
	public void fetch_data() {
		cancel_all_fetching();
		synchronized (this) {
			if (is_fetching_data)
				return;

			is_fetching_data = true;
			if (!queued_for_refreshes && ttl > 0) {
				Irekia.queue_refresh(this, ttl);
				queued_for_refreshes = true;
			}
		}

		currentRootDownloaderTask = new RootDownloaderTask(this, false);
		currentRootDownloaderTask.execute(langcode_url);
	}

	public void fetch_more_data() {
		cancel_all_fetching();
		synchronized (this) {
			if (is_fetching_data)
				return;

			is_fetching_data = true;
			if (!queued_for_refreshes && ttl > 0) {
				Irekia.queue_refresh(this, ttl);
				queued_for_refreshes = true;
			}
		}
		String url = langcode_url;
		//if current url has any parameter append last item as new param
		if (url.contains("?"))
			url += "&o=";
			//else, set last item as param
		else
			url += "?o=";
		url += items.get(items.size() - 1).id;
		currentRootDownloaderTask = new RootDownloaderTask(this, true);
		currentRootDownloaderTask.execute(url);
	}

	/**
	 * Checks if fetching is required due to ttl and last_update timestamps.
	 * Since overlords don't actually download scheduled refreshes if they are not
	 * being observed, this method has to be run by the activities willing to watch
	 * the overlords' items on their resume method.
	 * The method will calculate against the current time how much has ellapsed and
	 * if enough, start immediately a fetch.
	 */
	public void fetch_if_ttl_expired() {
		if (last_update + ttl * 1000 < System.currentTimeMillis() || items.size() == 0)
			fetch_data();
		else if (progress_reporter != null && progress_reporter.get() != null)
			progress_reporter.get().set_progress(10000);
	}

	/**
	 * Runnable implementation, starts a fetch and requeues itself.
	 */
	public void run() {
		fetch_data();
		Irekia.queue_refresh(this, ttl);
	}

	/**
	 * Retrieves a specific item according to id.
	 *
	 * @return The item or null if it wasn't found.
	 */
	public Content_item get_item(final int id) {
		for (Content_item item : items)
			if (id == item.id)
				return item;
		return null;
	}

	/**
	 * Returns the previous item from the specified one.
	 *
	 * @param ref The parameter you want to find it's previous, can be null.
	 * @return The previous item or null if it wasn't found.
	 */
	public Content_item get_prev(Content_item ref) {
		if (null == ref || null == items || items.size() < 2)
			return null;

		Content_item prev = null;
		for (Content_item item : items) {
			if (item.id == ref.id)
				return prev;
			prev = item;
		}
		return null;
	}


	/**
	 * Returns the nextStep item from the specified one.
	 *
	 * @param ref The parameter you want to find it's nextStep, can be null.
	 * @return The nextStep item or null if it wasn't found.
	 */
	public Content_item get_next(Content_item ref) {
		if (null == ref || null == items || items.size() < 2)
			return null;

		int f = items.size() - 1;
		Content_item next = items.get(f--);
		while (f >= 0) {
			Content_item item = items.get(f--);
			if (item.id == ref.id)
				return next;
			next = item;
		}
		return null;
	}

	/**
	 * Public entry for Broodling objects to replace the overlord's private vars.
	 * Even if you pass null objects this function will reset the is_fetching_data
	 * internal variable to false.
	 */
	public void replace(ArrayList<Content_item> new_items,
						ArrayList<Section_state> new_sections, boolean increment) {
		synchronized (this) {
			is_fetching_data = false;
			if (null != new_items) {
				assertTrue("Sections can't be null", null != new_sections);
				this.last_update = System.currentTimeMillis();
				this.sections = new_sections;
				if (increment)
					this.items.addAll(new_items);
				else
					this.items.replace(new_items);
			}
		}
	}

	/**
	 * Allows activities to set themselves as reporters of progress.
	 */
	public void set_progress_reporter(Activity_progress reporter) {
		if (null != reporter)
			progress_reporter = new WeakReference<Activity_progress>(reporter);
		else
			progress_reporter = null;
	}

	/**
	 * Relayed progress message of the Broodling.
	 * This method is supposed to communicate the progress to whatever observers
	 * are watching the Overlord. The method is run in the UI thread.
	 */
	public void onBroodlingUpdate(int progress) {
		Activity_progress reporter = null;
		if (null != progress_reporter)
			reporter = progress_reporter.get();
		if (null != reporter)
			reporter.set_progress(progress);
	}

/*************************** Section specific code *************************/

	/**
	 * Find an active section by section identifier.
	 *
	 * @return The section if found, null if it wasn't.
	 */
	public Section_state section_by_id(final int id) {
		if (null != sections)
			for (Section_state section : sections)
				if (id == section.id)
					return section;
		return null;
	}

	/**
	 * Finds a section position by index.
	 * You can pass any kind of index, this won't throw errors.
	 *
	 * @return The section if found, null if it wasn't.
	 */
	public Section_state section_by_pos(final int pos) {
		if (null != sections && pos >= 0 && pos < sections.size())
			return sections.get(pos);
		else
			return null;
	}

/*************************** New Methods to deal with Child items *************************/
/************* Child Items are those items that are not associated to an Overlord, *******/
/************************ are produced by tag search or text search *************************/


	/**
	 * Finds a Child section position by index.
	 * You can pass any kind of index, this won't throw errors.
	 *
	 * @return The Child section if found, null if it wasn't.
	 */
	public Section_state child_section_by_pos(final int pos) {
		if (null != child_sections && pos >= 0 && pos < child_sections.size())
			return child_sections.get(pos);
		else
			return null;
	}

	/**
	 * Finds a Child section position by index.
	 * You can pass any kind of index, this won't throw errors.
	 *
	 * @return The Child section if found, null if it wasn't.
	 */
	public Section_state volatile_section_by_pos(final int pos) {
		if (null != volatile_sections && pos >= 0 && pos < volatile_sections.size())
			return volatile_sections.get(pos);
		else
			return null;
	}

	/**
	 * Fills the Child items list with items produced by a query
	 * updates fetching data watchdog
	 */
	public void update_child_items(SmartList<Content_item> new_items, ArrayList<Section_state> new_sections, boolean increment) {
		if (new_items != null) {
			if (increment)
				//if request is incremental and rows returned append new items
				this.child_items.addAll(new_items);
			else {
				//if request is not incremental and rows returned replace new items
				this.child_sections = new_sections;
				this.child_items.replace(new_items);
			}
		} else {
			if (!increment) {
				//if request is not incremental and no rows returned clear list and notify
				child_sections = (new_sections != null) ? new_sections : new ArrayList<Section_state>();
				child_items.clear();
				this.current_paginated_result.set_can_fetch_more(false);
			} else {
				//if request is incremental and no rows returned just update more_items_row
				this.current_paginated_result.set_can_fetch_more(false);
			}
		}
		is_fetching_data = false;
	}

	/**
	 * Fills the Child items list with items produced by a query
	 * updates fetching data watchdog
	 */
	public void update_volatile_items(SmartList<Content_item> new_items, ArrayList<Section_state> new_sections, boolean increment) {
		if (new_items != null) {
			if (increment)
				//if request is incremental and rows returned append new items
				this.volatile_items.addAll(new_items);
			else {
				//if request is not incremental and rows returned replace new items
				this.volatile_sections = new_sections;
				this.volatile_items.replace(new_items);
			}
		} else {
			if (!increment) {
				//if request is not incremental and no rows returned clear list and notify
				volatile_sections = (new_sections != null) ? new_sections : new ArrayList<Section_state>();
				volatile_items.clear();
				this.current_volatile_paginated_result.set_can_fetch_more(false);
			} else {
				//if request is incremental and no rows returned just update more_items_row
				this.current_volatile_paginated_result.set_can_fetch_more(false);
			}
		}
		is_fetching_data = false;
	}

	/**
	 * When a navigation is produced, child items are stored to be able to restore them when going back
	 */

	public void save_previous_items(boolean clearList) {
		///As child_items is a smartList list iterate is needed to avoid concurrent modification
		List<Content_item> new_items = new ArrayList<Content_item>();
		for (Content_item vol : child_items)
			new_items.add(vol);
		//Update current PaginatedResult's items
		current_paginated_result.setCurrent_items(new_items);
		//Update current PaginatedResult's sections
		current_paginated_result.setCurrent_sections(child_sections);
		current_paginated_result.setRoot_item(last_selected_item);
		//Push current PaginatedResult to stack
		previous_child_items.push(current_paginated_result);
		if (clearList) {
			child_sections.clear();
			child_items.clear();
		}
	}

	/**
	 * When a navigation is produced, child items are stored to be able to restore them when going back
	 */

	public void save_previous_volatiles() {
		///As child_items is a smartList list iterate is needed to avoid concurrent modification
		List<Content_item> new_items = new ArrayList<Content_item>();
		for (Content_item vol : volatile_items)
			new_items.add(vol);
		//Update current PaginatedResult's items
		current_volatile_paginated_result.setCurrent_items(new_items);
		//Update current PaginatedResult's sections
		current_volatile_paginated_result.setCurrent_sections(volatile_sections);
		//Push current PaginatedResult to stack
		previous_volatile_items.push(current_volatile_paginated_result);
		volatile_sections.clear();
		volatile_items.clear();
	}

	/**
	 * When a back navigation is produced, child items are restored
	 */
	public void restore_previous_items() {
		PaginatedResult paginated_result = previous_child_items.pop();
		//Pop current PaginatedResult from stack to currentPaginatedResult
		current_paginated_result = paginated_result;
		last_selected_item = current_paginated_result.getRoot_item();
		//Update current child items from stack
		child_sections = paginated_result.getCurrent_sections();
		child_items.replace(new SmartList<Content_item>(paginated_result.getCurrent_items()));
	}

	/**
	 * When a back navigation is produced, child items are restored
	 */
	public void restore_previous_volatiles() {
		PaginatedResult paginated_result = previous_volatile_items.pop();
		//Pop current PaginatedResult from stack to currentPaginatedResult
		current_volatile_paginated_result = paginated_result;
		//Update current child items from stack
		volatile_sections = paginated_result.getCurrent_sections();
		volatile_items.replace(new SmartList<Content_item>(paginated_result.getCurrent_items()));
	}

	/**
	 * Retrieves a specific child item according to id.
	 *
	 * @return The child item or null if it wasn't found.
	 */
	public Content_item get_volatile_item(final int id) {
		for (Content_item item : volatile_items)
			if (id == item.id)
				return item;
		return null;
	}

	/**
	 * Returns the previous child item from the specified one.
	 *
	 * @param ref The parameter you want to find it's previous, can be null.
	 * @return The previous Child item or null if it wasn't found.
	 */
	public Content_item get_prev_volatile(Content_item ref) {
		if (null == ref || null == volatile_items || volatile_items.size() < 2)
			return null;

		Content_item prev = null;
		for (Content_item item : volatile_items) {
			if (item.id == ref.id)
				return prev;
			prev = item;
		}
		return null;
	}

	/**
	 * Returns the nextStep child item from the specified one.
	 *
	 * @param ref The parameter you want to find it's nextStep, can be null.
	 * @return The nextStep child item or null if it wasn't found.
	 */
	public Content_item get_next_volatile(Content_item ref) {
		if (null == ref || null == volatile_items || volatile_items.size() < 2)
			return null;

		int f = volatile_items.size() - 1;
		Content_item next = volatile_items.get(f--);
		while (f >= 0) {
			Content_item item = volatile_items.get(f--);
			if (item.id == ref.id)
				return next;
			next = item;
		}
		return null;
	}


	/**
	 * Starts a network request for child items in a separate thread.
	 * If you want to be notified of updates, just add yourself as observer to the
	 * smartlist.
	 */

	/**
	 * Retrieves a specific child item according to id.
	 *
	 * @return The child item or null if it wasn't found.
	 */
	public Content_item get_child_item(final int id) {
		for (Content_item item : child_items)
			if (id == item.id)
				return item;
		return null;
	}

	/**
	 * Returns the previous child item from the specified one.
	 *
	 * @param ref The parameter you want to find it's previous, can be null.
	 * @return The previous Child item or null if it wasn't found.
	 */
	public Content_item get_prev_child(Content_item ref) {
		if (null == ref || null == child_items || child_items.size() < 2)
			return null;

		Content_item prev = null;
		for (Content_item item : child_items) {
			if (item.id == ref.id)
				return prev;
			prev = item;
		}
		return null;
	}

	/**
	 * Returns the nextStep child item from the specified one.
	 *
	 * @param ref The parameter you want to find it's nextStep, can be null.
	 * @return The nextStep child item or null if it wasn't found.
	 */
	public Content_item get_next_child(Content_item ref) {
		if (null == ref || null == child_items || child_items.size() < 2)
			return null;

		int f = child_items.size() - 1;
		Content_item next = child_items.get(f--);
		while (f >= 0) {
			Content_item item = child_items.get(f--);
			if (item.id == ref.id)
				return next;
			next = item;
		}
		return null;
	}

/*************************** New Methods to deal with search_bar *****************************/
/************* Child Items are those items that are not associated to an Overlord, *******/
	/**
	 * ********************* are produced by tag search or text search ************************
	 */

	/**
	 * Returns true if current Overlor can search on it's content
	 *
	 * @return true if current Overlor can search or false if not
	 */
	public boolean is_searchable() {
		return search_bar_url != null && !search_bar_url.equals("");
	}

	/**
	 * Fills the child items by a query
	 */
	public void search(String criteria) {
		cancel_all_fetching();
		SearchPaginatedResult searchPaginatedResult = new SearchPaginatedResult(this, criteria);
		if (!this.last_selected_item.is_searchable())
			return;
		synchronized (this) {
			if (is_fetching_data)
				return;

			is_fetching_data = true;
			if (!queued_for_refreshes && ttl > 0) {
				Irekia.queue_refresh(this, ttl);
				queued_for_refreshes = true;
			}
		}
		this.current_volatile_paginated_result = searchPaginatedResult;
		currentVolatileDownloaderTask = new VolatileDownloaderTask(this, false, Irekia.MODE_SEARCH);
		currentVolatileDownloaderTask.execute(searchPaginatedResult.getSearch_url());
	}

	/**
	 * Fills the child items fetching data from tags url
	 */
	public void fetch_tags(String url) {
		cancel_all_fetching();
		TagsPaginatedResult tagsPaginatedResult = new TagsPaginatedResult(url);
		synchronized (this) {
			if (is_fetching_data)
				return;

			is_fetching_data = true;
			if (!queued_for_refreshes && ttl > 0) {
				Irekia.queue_refresh(this, ttl);
				queued_for_refreshes = true;
			}
		}
		this.current_volatile_paginated_result = tagsPaginatedResult;
		currentVolatileDownloaderTask = new VolatileDownloaderTask(this, false, Irekia.MODE_TAGS);
		currentVolatileDownloaderTask.execute(tagsPaginatedResult.getSearch_url());
	}

	/**
	 * Fills the child items fetching data from url (Videos and photos)
	 */
	public void fetch_child_items(String url) {
		cancel_all_fetching();
		SinglePaginatedResult singlePaginatedResult = new SinglePaginatedResult(this, url, Irekia.MODE_CHILD);
		synchronized (this) {
			if (is_fetching_data)
				return;

			is_fetching_data = true;
			if (!queued_for_refreshes && ttl > 0) {
				Irekia.queue_refresh(this, ttl);
				queued_for_refreshes = true;
			}
		}
		this.current_paginated_result = singlePaginatedResult;
		if (last_selected_item != null && last_selected_item.isOverlord()) {
			currentChildDownloaderTask = new ChildDownloaderTask(this, false);
			currentChildDownloaderTask.execute(singlePaginatedResult.getSearch_url());
		}
	}

	/**
	 * Fills the volatile items list fetching data from url (Videos and photos)
	 */
	public void fetch_volatile_items(String url, int mode) {
		cancel_all_fetching();
		System.out.println(url);
		SinglePaginatedResult singlePaginatedResult = new SinglePaginatedResult(this, url, mode);
		synchronized (this) {
			if (is_fetching_data)
				return;

			is_fetching_data = true;
			if (!queued_for_refreshes && ttl > 0) {
				Irekia.queue_refresh(this, ttl);
				queued_for_refreshes = true;
			}
		}
		this.current_volatile_paginated_result = singlePaginatedResult;
		currentVolatileDownloaderTask = new VolatileDownloaderTask(this, false, mode);
		currentVolatileDownloaderTask.execute(singlePaginatedResult.getSearch_url());
	}

	/**
	 * Fecth more child items asking nextStep url to current PaginatedResult
	 */
	public void fetch_more_child() {
		cancel_all_fetching();
		synchronized (this) {
			if (is_fetching_data)
				return;

			is_fetching_data = true;
			if (!queued_for_refreshes && ttl > 0) {
				Irekia.queue_refresh(this, ttl);
				queued_for_refreshes = true;
			}
		}
		current_paginated_result.next();
		if (last_selected_item != null && last_selected_item.isOverlord()) {
			currentChildDownloaderTask = new ChildDownloaderTask(this, false);
			String more_items_url = current_paginated_result.getMore_items_url();
			currentChildDownloaderTask.execute(more_items_url);
		}

	}

	/**
	 * Fecth more child items asking nextStep url to current PaginatedResult
	 */
	public void fetch_more_volatile(int mode) {
		cancel_all_fetching();
		synchronized (this) {
			if (is_fetching_data)
				return;

			is_fetching_data = true;
			if (!queued_for_refreshes && ttl > 0) {
				Irekia.queue_refresh(this, ttl);
				queued_for_refreshes = true;
			}
		}
		current_volatile_paginated_result.next();
		currentVolatileDownloaderTask = new VolatileDownloaderTask(this, true, mode);
		currentVolatileDownloaderTask.execute(current_volatile_paginated_result.getMore_items_url());

	}

	//Hardcoded way to know if current overlord can fetch more items or not
	//there is no way to know it with returned data
	public boolean overlord_can_fetch_more() {
		return langcode_url.contains("/news")
			|| langcode_url.contains("/photos")
			|| langcode_url.contains("/videos");
	}

	public void cancel_all_fetching() {
		cancel_main_fetching();
		cancel_child_fetching();
		cancel_volatile_fetching();
	}

	public void cancel_main_fetching() {
		if (currentRootDownloaderTask != null && (currentRootDownloaderTask.getStatus() == AsyncTask.Status.PENDING || currentRootDownloaderTask.getStatus() == AsyncTask.Status.RUNNING)) {
			currentRootDownloaderTask.cancel(true);
			is_fetching_data = false;
		}
	}

	public void cancel_volatile_fetching() {
		if (currentVolatileDownloaderTask != null && (currentVolatileDownloaderTask.getStatus() == AsyncTask.Status.PENDING || currentVolatileDownloaderTask.getStatus() == AsyncTask.Status.RUNNING)) {
			currentVolatileDownloaderTask.cancel(true);
			is_fetching_data = false;
		}
	}

	public void cancel_child_fetching() {
		if (currentChildDownloaderTask != null && (currentChildDownloaderTask.getStatus() == AsyncTask.Status.PENDING || currentChildDownloaderTask.getStatus() == AsyncTask.Status.RUNNING)) {
			currentChildDownloaderTask.cancel(true);
			is_fetching_data = false;
		}

	}

	public void go_home(Activity activity) {
		previous_child_items.empty();
		previous_volatile_items.empty();
		child_items.clear();
		child_sections.clear();
		current_paginated_result = null;
		current_volatile_paginated_result = null;
		volatile_items.clear();
		volatile_sections.clear();
		Intent intent = new Intent(activity, Main_activity.class);
		intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
		intent.putExtra(Irekia.MAIN_MUST_FETCH, false);
		activity.startActivity(intent);
	}
}
